#include "stdafx.h"
#include "auctionobject.h"

tAuctionObject::tAuctionObject()
{
}

tAuctionObject::tAuctionObject(ifstream& fpin, long size)
{
	int i;
	size1 = size;
	size2 = size;
	hdrsize = 18;
	strncpy(header, ".?AVtAuctionItem@@", 18);
	seperator = gGetInt32(fpin);
	for (i = 0; i < 6; i++) {
		fpin.get(objheader[i]);
	}
	identifier = gGetInt32(fpin);
	for (i = 0; i < 5; i++) {
		fpin.get(unknown[i]);
	}
	gGetString(fpin, typelen, shiptype);
	for (i = 0; i < 5; i++) {
		fpin.get(unknown2[i]);
	}
	shipid = gGetInt32(fpin);
	shipbpv1 = gGetInt32(fpin);
	shipbpv2 = gGetInt32(fpin);
	auctionrateA = gGetInt32(fpin);
	auctionrateB = gGetInt32(fpin);
	bidturn = gGetInt32(fpin);
	closeturn = gGetInt32(fpin);
	bidamount = gGetInt32(fpin);
	for (i = 0; i < 5; i++) {
		fpin.get(unknown5[i]);
	}
	bidderid = gGetInt32(fpin);
	bidmade = gGetInt32(fpin);
	overbid = gGetInt32(fpin);
	remaininglen = size1 - (hdrsize + typelen + 81);
	if (remaininglen > 0) {
		unknown6 = new char[remaininglen];
		for (i = 0; i < remaininglen; i++) {
			fpin.get(unknown6[i]);
		}
	} else {
		remaininglen = 0;
		unknown6 = NULL;
	}
}

tAuctionObject::~tAuctionObject()
{
	if (EDDebug) cout << "Deleting auction object" << endl;
	delete unknown6;
	delete shiptype;
}

	
tAuctionObject::mWriteToDB(ofstream& fpout)
{
	int i;
	gPutInt32(fpout, size1);
	gPutInt32(fpout, size2);
	gPutString(fpout, hdrsize, header);
	gPutInt32(fpout, seperator);
	for (i = 0; i < 6; i++) {
		fpout.put(objheader[i]);
	}
	gPutInt32(fpout, identifier);
	for (i = 0; i < 5; i++) {
		fpout.put(unknown[i]);
	}
	gPutString(fpout, typelen, shiptype);
	for (i = 0; i < 5; i++) {
		fpout.put(unknown2[i]);
	}
	gPutInt32(fpout, shipid);
	gPutInt32(fpout, shipbpv1);
	gPutInt32(fpout, shipbpv2);
	gPutInt32(fpout, auctionrateA);
	gPutInt32(fpout, auctionrateB);
	gPutInt32(fpout, bidturn);
	gPutInt32(fpout, closeturn);
	gPutInt32(fpout, bidamount);
	for (i = 0; i < 5; i++) {
		fpout.put(unknown5[i]);
	}
	gPutInt32(fpout, bidderid);
	gPutInt32(fpout, bidmade);
	gPutInt32(fpout, overbid);
	for (i = 0; i < remaininglen; i++) {
		fpout.put(unknown6[i]);
	}
	captainname = ""; // needs to be set when crossreferencing done
}

tAuctionObject::mWriteToReport(ofstream& fpout)
{
	int i;
	fpout << "Shipyard bid by " << bidderid << ":";
	fpout << " turn " << bidturn << ", closing " << closeturn;
	fpout << " amount " << bidamount << " on ship " << shipid << " ";
	for (i = 0; i < typelen; i++) {
		fpout.put(shiptype[i]);
	}
	fpout << " bpv " << shipbpv1 << endl << endl;
}
