#ifndef AUCTIONOBJECTH
#define AUCTIONOBJECTH 1

#include "commondefs.h"

class tAuctionObject {
public:
	tAuctionObject();
	tAuctionObject(ifstream &fpin, long size);
	~tAuctionObject();
	mWriteToDB(ofstream& fpout);
	mWriteToReport(ofstream& fpout);
	long mGetBidID() { return identifier; }
private:
	// data fields, in order they appear in the database,
	long size1, size2;
	long hdrsize;
	char header[19];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	long seperator;
	char objheader[6];
	long identifier;
	char unknown[5];
	long typelen;
	char *shiptype; // length given by typelen
	char unknown2[5];
	long shipid;
	long shipbpv1, shipbpv2; // ship and auction values
	long auctionrateA, auctionrateB;
	long bidturn; // turn bidding opened
	long closeturn;
	long bidamount;
	char unknown5[5];
	long bidderid;
	long bidmade; // turn bid was made on
	long overbid; // maximum bid
	char *unknown6; // balance of object size, if any
	long remaininglen;
	std::string captainname;
};

#endif