#include "stdafx.h"
#include "campaignobj.h"

tCampaignObject::tCampaignObject()
{
}

tCampaignObject::tCampaignObject(ifstream& fpin)
{
	header = NULL;
	campaignname = NULL;
	description = NULL;
	earlymap = NULL;
	middlemap = NULL;
	latemap = NULL;
	missionlist = NULL;
	racelist = NULL;
	triggermission = NULL;
	campaignname2 = NULL;
	version = NULL;
	clientversion = NULL;
	serverpwd = NULL;
	unknown16 = NULL;
	int i;
	size1 = gGetInt32(fpin);
	size2 = gGetInt32(fpin);

	gGetString(fpin, hdrsize, header);

	seperator = gGetInt32(fpin);
	for (i = 0; i < 6; i++) {
		fpin.get(objheader[i]);
	}
	identifier = gGetInt32(fpin);

	unknown = gGetInt32(fpin);
	gGetString(fpin, namelen, campaignname);

	gGetString(fpin, desclen, description);
	gGetString(fpin, earlylen, earlymap);
	gGetString(fpin, middlelen, middlemap);
	gGetString(fpin, latelen, latemap);
	nummissions = gGetInt32(fpin);
	if (nummissions <= 0) {
		missionlist = NULL;
		nummissions = 0; 
	} else {
		missionlist = new sMissionInfo[nummissions];
		for (i = 0; i < nummissions; i++) {
			missionlist[i].mission = NULL;
			gGetString(fpin, missionlist[i].namelen, missionlist[i].mission);
		}
	}
	numraces = gGetInt32(fpin);
	if (numraces < 1) {
		numraces = 0;
		racelist = NULL;
	} else {
		racelist = new long[numraces];
		for (i = 0; i < numraces; i++) {
			racelist[i] = gGetInt32(fpin);
		}
	}
	startera = gGetInt32(fpin);
	difficulty = gGetInt32(fpin);
	triggerprestige = gGetInt32(fpin);
	gGetString(fpin, triggerlen, triggermission);
	gGetString(fpin, namelen2, campaignname2);
	gGetString(fpin, spcaptnamelen, spcaptname);
	if (spcaptnamelen > 0) {
		gSetSPDB();
		gStoreCaptName(spcaptname, spcaptnamelen);
	}
	spcaptrace = gGetInt32(fpin);
	spprestige = gGetInt32(fpin);
	serverpwdlen = gGetInt32(fpin);
	fpin.get(serverpwd);
	turnssofar = gGetInt32(fpin);
	gSetCurrentTurn(turnssofar);
	curryear = gGetInt32(fpin);
	turnsperyear = gGetInt32(fpin);
	lengthofturn = gGetInt32(fpin);
	baseyear = gGetInt32(fpin);
	earlyerastart = gGetInt32(fpin);
	miderastart = gGetInt32(fpin);
	lateerastart = gGetInt32(fpin);
	if (!gIsEAWCampaign()) {
		// get start of advanced era
		adverastart = gGetInt32(fpin);
	}

	long currentyear = turnssofar / turnsperyear;
	if (currentyear < miderastart) gSetCurrentEra(0);
	else if (currentyear < lateerastart) gSetCurrentEra(1);
	else if (gIsEAWCampaign() || (currentyear < adverastart)) gSetCurrentEra(2);
	else gSetCurrentEra(3);

	numaccounts = gGetInt32(fpin);
	maxaccounts = gGetInt32(fpin);
	numplaying = gGetInt32(fpin);
	maxplaying = gGetInt32(fpin);
	gGetString(fpin, versionlen, version);
	gGetString(fpin, clientversionlen, clientversion);
	remaininglen = size1 - 143;
	remaininglen = remaininglen - (4 * (nummissions + numraces));
	remaininglen = remaininglen - hdrsize;
	remaininglen = remaininglen - namelen;
	remaininglen = remaininglen - desclen;
	remaininglen = remaininglen - earlylen;
	remaininglen = remaininglen - middlelen;
	remaininglen = remaininglen - latelen;
	remaininglen = remaininglen - triggerlen;
	remaininglen = remaininglen - namelen2;
	remaininglen = remaininglen - versionlen;
	remaininglen = remaininglen - clientversionlen;
	if (!gIsEAWCampaign()) {
		remaininglen = remaininglen - 4;
	}
	for (i = 0; i < nummissions; i++) {
		remaininglen = remaininglen - missionlist[i].namelen;
	}
	remaininglen = remaininglen - spcaptnamelen;
	if (remaininglen < 1) {
		remaininglen = 0;
		unknown16 = NULL;
	} else {
		unknown16 = new char[remaininglen];
		for (i = 0; i < remaininglen; i++) {
			fpin.get(unknown16[i]);
		}
	}
}

tCampaignObject::~tCampaignObject()
{
	if (EDDebug) cout << "Deleting campaign object" << endl;
}

void tCampaignObject::mWriteToDB(ofstream& fpout)
{
	int i;
	gPutInt32(fpout, size1);
	gPutInt32(fpout, size2);
	gPutString(fpout, hdrsize, header);
	gPutInt32(fpout, seperator);
	for (i = 0; i < 6; i++) {
		fpout.put(objheader[i]);
	}
	gPutInt32(fpout, identifier);
	gPutInt32(fpout, unknown);
	gPutString(fpout, namelen, campaignname);
	gPutString(fpout, desclen, description);
	gPutString(fpout, earlylen, earlymap);
	gPutString(fpout, middlelen, middlemap);
	gPutString(fpout, latelen, latemap);
	gPutInt32(fpout, nummissions);
	for (i = 0; i < nummissions; i++) {
		gPutString(fpout, missionlist[i].namelen, missionlist[i].mission);
	}
	gPutInt32(fpout, numraces);
	for (i = 0; i < numraces; i++) {
		gPutInt32(fpout, racelist[i]);
	}
	gPutInt32(fpout, startera);
	gPutInt32(fpout, difficulty);
	gPutInt32(fpout, triggerprestige);
	gPutString(fpout, triggerlen, triggermission);
	gPutString(fpout, namelen2, campaignname2);
	gPutString(fpout, spcaptnamelen, spcaptname);
	gPutInt32(fpout, spcaptrace);
	gPutInt32(fpout, spprestige);
	gPutInt32(fpout, serverpwdlen);
	fpout.put(serverpwd);
	gPutInt32(fpout, turnssofar);
	gPutInt32(fpout, curryear);
	gPutInt32(fpout, turnsperyear);
	gPutInt32(fpout, lengthofturn);
	gPutInt32(fpout, baseyear);
	gPutInt32(fpout, earlyerastart);
	gPutInt32(fpout, miderastart);
	gPutInt32(fpout, lateerastart);
	if (!gIsEAWCampaign()) {
		gPutInt32(fpout, adverastart);
	}
	gPutInt32(fpout, numaccounts);
	gPutInt32(fpout, maxaccounts);
	gPutInt32(fpout, numplaying);
	gPutInt32(fpout, maxplaying);
	gPutString(fpout, versionlen, version);
	gPutString(fpout, clientversionlen, clientversion);
	for (i = 0; i < remaininglen; i++) {
		fpout.put(unknown16[i]);
	}
}

void tCampaignObject::mWriteCampInfo()
{
	int i;
	ofstream fpout;

	fpout.open("camp.info",ios::binary);
	if (fpout.fail()) {
		cout << "Unable to produce matching camp.info file" << endl;
	} else {
		cout << "Producing an updated camp.info file" << endl;
		gPutInt32(fpout, size1 - 23);
		gPutInt32(fpout, seperator);
		for (i = 0; i < 6; i++) {
			fpout.put(objheader[i]);
		}
		gPutInt32(fpout, identifier);
		gPutInt32(fpout, unknown);
		gPutString(fpout, namelen, campaignname);
		gPutString(fpout, desclen, description);
		gPutString(fpout, earlylen, earlymap);
		gPutString(fpout, middlelen, middlemap);
		gPutString(fpout, latelen, latemap);
		gPutInt32(fpout, nummissions);
		for (i = 0; i < nummissions; i++) {
			gPutString(fpout, missionlist[i].namelen, missionlist[i].mission);
		}
		gPutInt32(fpout, numraces);
		for (i = 0; i < numraces; i++) {
			gPutInt32(fpout, racelist[i]);
		}
		gPutInt32(fpout, startera);
		gPutInt32(fpout, difficulty);
		gPutInt32(fpout, triggerprestige);
		gPutString(fpout, triggerlen, triggermission);
		gPutString(fpout, namelen2, campaignname2);
		gPutString(fpout, spcaptnamelen, spcaptname);
		gPutInt32(fpout, spcaptrace);
		gPutInt32(fpout, spprestige);
		gPutInt32(fpout, serverpwdlen);
		fpout.put(serverpwd);
		gPutInt32(fpout, turnssofar);
		// OP Differs after here
		gPutInt32(fpout, curryear);
		gPutInt32(fpout, turnsperyear);
		gPutInt32(fpout, lengthofturn);
		gPutInt32(fpout, baseyear);
		gPutInt32(fpout, earlyerastart);
		gPutInt32(fpout, miderastart);
		gPutInt32(fpout, lateerastart);
		if (!gIsEAWCampaign()) {
			gPutInt32(fpout, adverastart);
		}
		gPutInt32(fpout, numaccounts);
		gPutInt32(fpout, maxaccounts);
		gPutInt32(fpout, numplaying);
		gPutInt32(fpout, maxplaying);
		gPutString(fpout, versionlen, version);
		gPutString(fpout, clientversionlen, clientversion);
		fpout.close();
	}

	fpout.open("version.info",ios::binary);
	if (fpout.fail()) {
		cout << "Unable to produce matching version.info file" << endl;
	} else {
		cout << "Producing an updated version.info file" << endl;
		for (i = 0; i < versionlen; i++) {
			fpout << version[i];
		}
		fpout << ((char)(10l));
		fpout.close();
	}
}

void tCampaignObject::mWriteToReport(ofstream& fpout)
{
	int i, j;
	fpout << endl;
	if (namelen < 1) {
		fpout << "Campaign Information" << endl;
		fpout << "====================" << endl;
	} else {
		for (i = 0; i < namelen; i++) fpout.put(campaignname[i]);
		fpout << endl;
		for (i = 0; i < namelen; i++) fpout.put('=');
		fpout << endl;
	}
	if (desclen < 1) {
		fpout << "No description given" << endl << endl;
	} else {
		for (i = 0; i < desclen; i++) fpout.put(description[i]);
		fpout << endl << endl;
	}

	if (difficulty == 0) {
		fpout << "Difficulty level: easy" << endl;
	} else if (difficulty == 1) {
		fpout << "Difficulty level: medium" << endl;
	} else if (difficulty == 2) {
		fpout << "Difficulty level: hard" << endl;
	} else {
		fpout << "Difficulty level: unknown (" << difficulty << ")" << endl;
	}

	if (startera == 0) {
		fpout << "Starts in early era, year " << (baseyear + earlyerastart) << " with map: ";
		if (earlylen < 1) fpout << "unspecified" << endl;
		else {
			for (i = 0; i < earlylen; i++) fpout.put(earlymap[i]);
			fpout << endl;
		}
		fpout << "Mid era starts in year " << (baseyear + miderastart);
		fpout << ", late era starts in year " << (baseyear + lateerastart) << endl;
	} else if (startera == 1) {
		fpout << "Start in middle era, year " << (baseyear + miderastart) << " with map: ";
		if (middlelen < 1) fpout << "unspecified" << endl;
		else {
			for (i = 0; i < middlelen; i++) fpout.put(middlemap[i]);
			fpout << endl;
		}
		fpout << "Late era starts in year " << (baseyear + lateerastart) << endl;
	} else if (startera == 2) {
		fpout << "Start in late era, year " << (baseyear + lateerastart) << " with map: ";
		if (latelen < 1) fpout << "unspecified" << endl;
		else {
			for (i = 0; i < latelen; i++) fpout.put(latemap[i]);
			fpout << endl;
		}
	} else {
		fpout << "Unspecified start era: " << startera << endl;
	}
	fpout << "Current date is " << (baseyear + (turnssofar / turnsperyear));
	fpout << "." << (turnssofar % turnsperyear) << endl;
	fpout << endl;
	fpout << "Mission list (" << (nummissions) << ")" << endl;
	fpout << "==================" << endl;
	for (i = 0; i < nummissions; i++) {
		for (j = 0; j < missionlist[i].namelen; j++) {
			fpout.put(missionlist[i].mission[j]);
		}
		fpout << endl;
	}
	if (triggerlen > 0) {
		fpout << "Special campaign missions begin with ";
		for (i = 0; i < triggerlen; i++) fpout.put(triggermission[i]);
		fpout << " starting at prestige " << triggerprestige << endl;
	} else {
		fpout << "No special campaign missions" << endl;
	}
	fpout << endl;
	fpout << "Playable races:";
	for (i = 0; i < numraces; i++) {
		long race = racelist[i];
		std::string racename = gGetRaceName(race);
		fpout << racename.c_str() << ",";
	}
	fpout << endl << endl;
	fpout << "Accounts created: " << numaccounts << ", of maximum " << maxaccounts << endl;
	fpout << "Currently online: " << numplaying << ", of maximum " << maxplaying << endl;
	fpout << endl;
	fpout << "Running server version ";
	for (i = 0; i < versionlen; i++) fpout.put(version[i]);
	fpout << endl << endl;
	fpout << "Expecting client version ";
	for (i = 0; i < clientversionlen; i++) fpout.put(clientversion[i]);
	fpout << endl << endl;
	if (spcaptnamelen > 0) {
		fpout << "Single player campaign: captain ";
		for (i = 0; i < spcaptnamelen; i++) {
			fpout << spcaptname[i];
		}
		std::string racename = gGetRaceName(spcaptrace);
		fpout << ", " << racename.c_str() << ",";
		fpout << " prestige " << spprestige << endl; 
	}
	fpout << "   Current year: " << curryear << endl;
	fpout << endl;

}

void tCampaignObject::mModifyCampaign()
{
	char newstring[256];
	char cmd;
	long diff;
	long temp;
	long *tptr;
	sMissionInfo *tlist;
	int i;
	bool found = false;
	long currpos, lastpos;
	cout << endl << "EDITING MAIN CAMPAIGN DETAILS" << endl;

	do {
		cout << "Enter D to modify the difficulty level" << endl;
		cout << "   or Y to modify the number of turns per year" << endl;
		cout << "   or L to modify the length of a turn" << endl;
		cout << "   or E to modify the start dates for eras" << endl;
		cout << "   or A to modify the maximum number of accounts" << endl;
		cout << "   or P to modify the maximum number of people playing" << endl;
		cout << "   or C to modify the campaign name and description" << endl;
		cout << "   or V to modify the save game version" << endl;
		cout << "   or S to modify the single-player captain name" << endl;
		cout << "   or T to modify the single-player trigger mission/prestige" << endl;
		cout << "   or R to modify the race list" << endl;
		cout << "   or M to modify the mission list" << endl;
		cout << "   or Q to quit this edit menu" << endl << endl;
		cout << "WARNING: there is no error checking, and no UNDO, so BE CAREFUL!" << endl;
		cin >> cmd;
		switch (cmd) {

			case 'M':
			case 'm':
				cout << "Enter the filename of the mission you wish to alter (e.g. Met_10Patrol.scr)" << endl;
				cin.getline(newstring, 255); // to get rid of buffer garbage
				cin.getline(newstring, 255);
				do {
					cout << "Enter A to add the mission to the current list" << endl;
					cout << "   or R to remove it from the current list" << endl;
					cout << "   or C to cancel this change" << endl;
					cin >> cmd;
				} while ((cmd != 'r') && (cmd != 'R') && (cmd != 'C') && (cmd != 'c') && (cmd != 'a') && (cmd != 'A'));
				if ((cmd == 'r') || (cmd == 'R')) {
					currpos = 0; lastpos = 0;
					while (lastpos < nummissions) {
						if ((missionlist[lastpos].namelen != strlen(newstring)) ||
							(strncmp(missionlist[lastpos].mission, newstring, missionlist[lastpos].namelen) != 0)){
							missionlist[currpos].mission = missionlist[lastpos].mission;
							missionlist[currpos].namelen = missionlist[lastpos].namelen;
							currpos++;
						} else {
							size1 = size1 - 4;
							size1 = size1 - missionlist[lastpos].namelen;
							delete missionlist[lastpos].mission;
							size2 = size1;
						}
						lastpos++;
					}
					nummissions = currpos;
				} else if ((cmd == 'A') || (cmd == 'a')) {
					found = false;
					for (i = 0; i < nummissions; i++) {
						if ((strlen(newstring) == missionlist[i].namelen) && 
							(strncmp(missionlist[i].mission, newstring, missionlist[i].namelen) == 0)) {
							found = true;
						}
					}
					if (!found) {
						// need to create a new mission list, one larger than the old one,
						// copy all the contents across,
						// and add the new mission as the last one
						// and increase the number of missions
						// and increase the object sizes by 4 + the string length
						// and deallocate the old mission list
						nummissions++;
						tlist = new sMissionInfo[nummissions];
						for (i = 0; i < nummissions; i++) {
							tlist[i].mission = missionlist[i].mission;
							tlist[i].namelen = missionlist[i].namelen;
						}
						tlist[nummissions-1].namelen = strlen(newstring);
						tlist[nummissions-1].mission = new char[strlen(newstring)];
						for (i = 0; i < tlist[nummissions-1].namelen; i++) {
							tlist[nummissions-1].mission[i] = newstring[i];
						}
						size1 += 4;
						size1 += strlen(newstring);
						size2 = size1;
						delete missionlist;
						missionlist = tlist;
					}
				}
				break;

			case 'R':
			case 'r':
				cout << "Enter the number of the race you wish to alter" << endl;
				cout << "0=Fed,1=Kli,2=Rom,3=Lyr,4=Hyd,5=Gor,6=ISC,7=Mir" << endl;
				if (!gIsEAWCampaign()) {
					cout << "8=Ori,9=Kor,10=Pri,11=Tig,12=Bea,13=Syn,14=Wyl,15=Cam" << endl;
				}
				cin >> temp;
				do {
					cout << "Enter A to add the race to the current list (make it playable)" << endl;
					cout << "   or R to remove the race from the current list" << endl;
					cout << "   or C to cancel this change" << endl;
					cin >> cmd;
				} while ((cmd != 'r') && (cmd != 'R') && (cmd != 'C') && (cmd != 'c') && (cmd != 'a') && (cmd != 'A'));
				if ((cmd == 'r') || (cmd == 'R')) {
					currpos = 0; lastpos = 0;
					while (lastpos < numraces) {
						if (racelist[lastpos] != temp) {
							racelist[currpos] = racelist[lastpos];
							currpos++;
						} else {
							size1 = size1 - 4;
							size2 = size1;
						}
						lastpos++;
					}
					numraces = currpos;
				} else if ((cmd == 'A') || (cmd == 'a')) {
					found = false;
					for (i = 0; i < numraces; i++) {
						if (racelist[i] == temp) found = true;
					}
					if (!found) {
						numraces++;
						tptr = new long[numraces];
						size1 += 4;
						size2 = size1;
						for (i = 0; i < (numraces-1); i++) {
							tptr[i] = racelist[i];
						}
						tptr[numraces-1] = temp;
						delete racelist;
						racelist = tptr;
					}
				}
				break;

			case 'T':
			case 't':
				cout << "Enter the prestige level at which the special campaign missions will trigger";
				cout << " (currently:" << triggerprestige << ")" << endl;
				cin >> triggerprestige;
				cout << "Enter the name for the first mission in the special campaign (currently:";
				for (i = 0; i < triggerlen; i++) {
					cout << triggermission[i];
				}
				cout << ")" << endl;
				cin.getline(newstring, 255); // to get rid of buffer garbage
				cin.getline(newstring, 255);
				size1 = size1 + gReplaceString(triggermission, triggerlen, newstring);
				size2 = size1;
				break;

			case 'V':
			case 'v':
				cout << "Enter the new server version number (currently:";
				for (i = 0; i < versionlen; i++) {
					cout << version[i];
				}
				cout << ")" << endl;
				cin.getline(newstring, 255); // to get rid of buffer garbage
				cin.getline(newstring, 255);
				diff = gReplaceString(version, versionlen, newstring);
				size1 = size1 + diff;

				cout << "Enter the new client version number (currently:";
				for (i = 0; i < clientversion[i]; i++) {
					cout << clientversion[i];
				}
				cout << ")" << endl;
				cin.getline(newstring, 255); // to get rid of buffer garbage
				cin.getline(newstring, 255);
				diff = gReplaceString(clientversion, clientversionlen, newstring);
				size2 = size2 + diff;
				break;

			case 'S':
			case 's':
				cout << "Enter the new name (max 255 characters, currently:";
				for (i = 0; i < spcaptnamelen; i++) {
					cout << spcaptname[i];
				}
				cout << ")" << endl;
				cin.getline(newstring, 255); // to get rid of garbage entries
				cin.getline(newstring, 255);
				size1 = size1 + gReplaceString(spcaptname, spcaptnamelen, newstring);
				size2 = size1;
				cout << "NOTE: you muast also go to the character edit section and" << endl;
				cout << "      modify the appropriate character information there" << endl;
				break;

			case 'D':
			case 'd':
				cout << "Enter the difficulty level: 0, 1, or 2 (currently:" << difficulty << endl;
				cin >> difficulty;
				break;

			case 'Y':
			case 'y':
				cout << "Enter the number of turns per year (currently:" << turnsperyear << ")" << endl;
				cin >> turnsperyear;
				break;

			case 'L':
			case 'l':
				cout << "Enter the length of a turn in milliseconds (currently:" << lengthofturn << ")" << endl;
				cin >> lengthofturn;
				break;

			case 'E':
			case 'e':
				cout << "Enter the start date for mid era (currently:" << miderastart << ")" << endl;
				cin >> miderastart;
				cout << "Enter the start date for late era (currently:" << lateerastart << ")" << endl;
				cin >> lateerastart;
				break;

			case 'A':
			case 'a':
				cout << "Enter the maximum permissible number of accounts (currently:" << maxaccounts << ")" << endl;
				cin >> maxaccounts;
				break;

			case 'P':
			case 'p': 
				cout << "Enter the maximum number of people allowed on at once (currently:" << maxplaying << ")" << endl;
				cin >> maxplaying;
				break;

			case 'C':
			case 'c':
				cin.getline(newstring, 255); // just to get rid of old return

				// get the user to enter the new campaign name
				cout << "Enter the new campaign name (max 255 characters, currently:";
				for (i = 0; i < namelen; i++) {
					cout << campaignname[i];
				}
				cout << ")" << endl;
				cin.getline(newstring, 255);
				diff = gReplaceString(campaignname, namelen, newstring);
				size1 = size1 + diff;
				size2 = size1;

				// also use this info to update the second stored campaign name
				strncpy(campaignname2, campaignname, namelen);
				namelen2 = namelen;
				size1 = size1 + diff;
				size2 = size1;

				// get the user to enter the new campaign description
				cout << "Enter the new campaign description (max 255 characters, currently:";
				for (i = 0; i < desclen; i++) {
					cout << description[i];
				}
				cout << ")" << endl;
				cin.getline(newstring, 255);
				delete description;
				description = new char[strlen(newstring)];
				for (i = 0; i < strlen(newstring); i++) {
					description[i] = newstring[i];
				}
				size1 = size1 + strlen(newstring) - desclen;
				desclen = strlen(newstring);
				size2 = size1;
				break;

			case 'Q':
			case 'q':
				cout << "Leaving campaign modification menu" << endl;
				break;

			default:
				cout << "Invalid command entered, please try again" << endl;
				mModifyCampaign();
				break;
		}
	} while ((cmd != 'q') && (cmd != 'Q'));
}
