#ifndef CAMPAIGNOBJH
#define CAMPAIGNOBJH 1

#include "commondefs.h"

class tCampaignObject {
public:
	tCampaignObject();
	tCampaignObject(ifstream& fpin);
	~tCampaignObject();
	void mWriteToDB(ofstream& fpout);
	void mWriteToReport(ofstream& fpout);
	void mWriteCampInfo();
	void mModifyCampaign();
	void mSetSPRace(long race) { spcaptrace = race; }
	void mSetSPPrestige(long prestige) { spprestige = prestige; }
	char *mGetMainPlayerName() { return spcaptname; }

private:
	// data fields, in order they appear in the database
	long size1, size2;
	long hdrsize;
	char *header;
	long seperator;
	char objheader[6];
	long identifier;
	long unknown;
	long namelen;
	char *campaignname; // length given by namelen
	long desclen;
	char *description; // length given by desclen
	long earlylen;
	char *earlymap; // length given by earlylen
	long middlelen;
	char *middlemap; // length given by middlelen
	long latelen;
	char *latemap; // length given by latelen
	long nummissions;
	struct sMissionInfo {
		long namelen;
		char *mission; // length given by namelen
	};
	sMissionInfo *missionlist; // length given by nummissions
	long numraces;
	long *racelist; // length given by numraces
	long startera;
	long difficulty;
	long triggerprestige;
	long triggerlen;
	char *triggermission; // length given by triggerlen
	long namelen2;
	char *campaignname2; // length given by namelen2
	long spcaptnamelen;
	char *spcaptname;
	long spcaptrace;
	long spprestige;
	long serverpwdlen;
	char serverpwd;
	long turnssofar;
	long curryear;
	long turnsperyear, lengthofturn, baseyear;
	long earlyerastart, miderastart, lateerastart, adverastart;
	long numaccounts;
	long maxaccounts;
	long numplaying;
	long maxplaying;
	long versionlen;
	char *version; // length given by versionlen
	long clientversionlen;
	char *clientversion; // length given by clientversionlen
	long remaininglen;
	char *unknown16; // length is balance of object size
};

#endif