#include "stdafx.h"
#include "characterobject.h"

tCharacterObject::tCharacterObject()
{
}

tCharacterObject::tCharacterObject(ifstream& fpin, long size)
{
	int i, j;
	// data fields, in order they appear in the database,
	// long size1, size2;
	// long hdrsize;
	// long header[20];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	size1 = size;
	size2 = size;
	hdrsize = 20;
	strncpy(header, ".?AVtServCharacter@@", 20);
	seperator = gGetInt32(fpin);
	for (i = 0; i < 6; i++) {
		fpin.get(objheader[i]);
	}
	identifier = gGetInt32(fpin);
	unknown1 = gGetInt32(fpin);
	unknown2 = gGetInt32(fpin);
	numbids = gGetInt32(fpin);
	if (numbids > 0) {
		currbids = new sBidObj[numbids];
		for (i = 0; i < numbids; i++) {
			for (j = 0; j < 5; j++) {
				fpin.get(currbids[i].unknown[j]);
			}
			currbids[i].bidderid = gGetInt32(fpin);
		}
	} else {
		numbids = 0;
		currbids = NULL;
	}
	remaininglen = size1;
	shipcount = gGetInt32(fpin);
	if (shipcount > 0) {
		currships = new sShipObj[shipcount];
		for (i = 0; i < shipcount; i++) {
			for (j = 0; j < 10; j++) {
				fpin.get(currships[i].unknown[j]);
			}
			currships[i].shipid = gGetInt32(fpin);
			currships[i].shipbpv = gGetInt32(fpin);
			currships[i].hullclass = gGetInt32(fpin);
			gGetString(fpin, currships[i].typelen, currships[i].shiptype);
			remaininglen = remaininglen - currships[i].typelen;
			currships[i].damageratio = gGetInt32(fpin);
			gGetString(fpin, currships[i].namelen, currships[i].shipname);
			remaininglen = remaininglen - currships[i].namelen;
			currships[i].damageflags = gGetInt32(fpin);
			remaininglen = remaininglen - 38;
		}
	} else {
		currships = NULL;
		shipcount = 0;
	}
	gGetString(fpin, namelen, captname);
	glicko = gGetInt32(fpin);
	prestige = gGetInt32(fpin);
	lifetime = gGetInt32(fpin);
	missions_flown = gGetInt32(fpin);

	// next 9 bytescover last battle result
	battleresult = gGetInt32(fpin);
	for (i = 0; i < 5; i++) {
		fpin.get(unknown5[i]);
	}


	column = gGetInt32(fpin);
	row = gGetInt32(fpin);

	// next 21 bytes cover time move comples, move destination,
	//     and mission slot id
	unknown6 = gGetInt32(fpin);
	for (i = 0; i < 17; i++) {
		fpin.get(unknown7[i]);
	}

	medals = gGetInt32(fpin);
	race = gGetInt32(fpin);
	rank = gGetInt32(fpin);
	race3 = gGetInt32(fpin);
	flags = gGetInt32(fpin);

	remaininglen = remaininglen - (namelen + 132 + (9 * numbids));

	// if this is SP and this isn't the key player then it's an AI
	if ((!gIsServerDB()) && (strncmp(captname, gGetCaptName(), namelen) != 0)) {
		AIcaptain = true;
	}

	// otherwise if there isn't enough information attached to
	// describe a human player then it's an AI
	else if (gIsServerDB() && (remaininglen < 24)) {
		AIcaptain = true;
	}

	// otherwise assume it's a human player and parse accordingly
	else {
		AIcaptain = false;
		// the following are only present if the character is not an AI
		// long emaillen;
		gGetString(fpin, emaillen, emailaddr);
		// char *emailaddr; // length given by emaillen
		// long seperator2;
		seperator2 = gGetInt32(fpin);
		// long iplen; // 0 for SP
		// char *ipaddr; // length given by iplen
		gGetString(fpin, iplen, ipaddr);
		// long seperator3;
		seperator3 = gGetInt32(fpin);

		// 9 bytes of rubbish (actually next mission title
		//   and score for next mission in campaigns)
		for (int k = 0; k < 9; k++) fpin.get(rubbish[i]);

		// long column2; // speculative
		homeworld_col = gGetInt32(fpin);
		// long homeworld_row; // speculative
		homeworld_row = gGetInt32(fpin);
		remaininglen = remaininglen - (33 + emaillen + iplen);
	}
	if (remaininglen > 0) {
		// remainder includes the last must play location
		// and the prepared missions id if the player had
		// missions offered when the db save was done
		unknown12 = new char[remaininglen];
		for (i = 0; i < remaininglen; i++) {
			fpin.get(unknown12[i]);
		}
	} else {
		remaininglen = 0;
		unknown12 = NULL;
	}
	// char *unknown12; // the balance of the object
}

tCharacterObject::~tCharacterObject()
{
	if (EDDebug) cout << "Deleting character object" << endl;
	delete currbids;
	int i;
	for (i = 0; i < shipcount; i++) {
		delete currships[i].shiptype;
		delete currships[i].shipname;
	}
	delete currships;
	delete captname;
	delete emailaddr;
	delete ipaddr;
	delete unknown12;
}

void tCharacterObject::mWriteToDB(ofstream& fpout)
{
	int i, j;
	// data fields, in order they appear in the database,
	// long size1, size2;
	// long hdrsize;
	// long header[20];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	gPutInt32(fpout, size1);
	gPutInt32(fpout, size2);
	gPutString(fpout, hdrsize, header);
	gPutInt32(fpout, seperator);
	for (i = 0; i < 6; i++) {
		fpout.put(objheader[i]);
	}
	gPutInt32(fpout, identifier);
	gPutInt32(fpout, unknown1);
	gPutInt32(fpout, unknown2);
	gPutInt32(fpout, numbids);
	for (i = 0; i < numbids; i++) {
		for (j = 0; j < 5; j++) {
			fpout.put(currbids[i].unknown[j]);
		}
		gPutInt32(fpout, currbids[i].bidderid);
	}
	gPutInt32(fpout, shipcount);
	for (i = 0; i < shipcount; i++) {
		for (j = 0; j < 10; j++) {
			fpout.put(currships[i].unknown[j]);
		}
		gPutInt32(fpout, currships[i].shipid);
		gPutInt32(fpout, currships[i].shipbpv);
		gPutInt32(fpout, currships[i].hullclass);
		gPutString(fpout, currships[i].typelen, currships[i].shiptype);
		gPutInt32(fpout, currships[i].damageratio);
		gPutString(fpout, currships[i].namelen, currships[i].shipname);
		gPutInt32(fpout, currships[i].damageflags);
	}
	gPutString(fpout, namelen, captname);
	gPutInt32(fpout, glicko);
	gPutInt32(fpout, prestige);
	gPutInt32(fpout, lifetime);
	gPutInt32(fpout, missions_flown);
	gPutInt32(fpout, battleresult);
	for (i = 0; i < 5; i++) {
		fpout.put(unknown5[i]);
	}
	gPutInt32(fpout, column);
	gPutInt32(fpout, row);
	gPutInt32(fpout, unknown6);
	for (i = 0; i < 17; i++) {
		fpout.put(unknown7[i]);
	}
	gPutInt32(fpout, medals);
	gPutInt32(fpout, race);
	gPutInt32(fpout, rank);
	gPutInt32(fpout, race3);
	gPutInt32(fpout, flags);

	if (!AIcaptain) {
		// the following are only present if the character is not an AI
		// long emaillen;
		gPutString(fpout, emaillen, emailaddr);
		gPutInt32(fpout, seperator2);
		gPutString(fpout, iplen, ipaddr);
		gPutInt32(fpout, seperator3);
		// 9 bytes are next mission title and score
		for (i = 0; i < 9; i++) fpout.put(rubbish[i]);
		gPutInt32(fpout, homeworld_col);
		gPutInt32(fpout, homeworld_row);
	}

	// char *unknown12; // last must play location, and prepared mission object id
	for (i = 0; i < remaininglen; i++) {
		fpout.put(unknown12[i]);
	}
}

bool tCharacterObject::mModifyCaptain()
{
	char newline[256];
	cout << "Enter H to modify the hex the character is in" << endl;
	cout << "   or R to modify their race" << endl;
	cout << "   or G to modify their glicko" << endl;
	cout << "   or P to modify their current prestige" << endl;
	cout << "   or L to modify their lifetime prestige" << endl;
	cout << "   or E to modify their email address" << endl;
	cout << "   or N to modify their name" << endl;
	cout << "   or K to modify their rank" << endl;
	cout << "   or W to modify the hex to treat as their home location" << endl;
	cout << "   or S to end this segment and move on to the player\'s ships" << endl << endl;
	cout << "WARNING: there is no error checking, and no UNDO, so BE CAREFUL!" << endl;
	char cmd;
	int i;
	long difference;
	cin >> cmd;
	switch (cmd) {
		case 'r':
		case 'R':
			cout << "Enter their new race (currently:" << race << ")" << endl;
			cout << "0=Fed,1=Kli,2=Rom,3=Lyr,4=Hyd,5=Gor,6=ISC,7=Mir" << endl;
			if (!gIsEAWCampaign()) {
				cout << "8=Ori,9=Kor,10=Pri,11=Tig,12=Bea,13=Syn,14=Wyl,15=Cam" << endl;
			}
			cin >> race;
			race3 = race;
			cout << "(Remember to edit their ship(s) to change the race there also)" << endl;
		case 'W':
		case 'w':
			cout << "Enter the hex row and column for the homeworld of their new race, row first" << endl;
			cin >> homeworld_row; cin >> homeworld_col;
			break;

		case 'k':
		case 'K':
			cout << "Enter their new rank (currently:" << rank << ")" << endl;
			cout << "0=Ensn,1=Lt,2=LtCmdr,3=Capt,4=Comm,5=R.Adm,6=Adm,7=Flt.Adm" << endl;
			cin >> rank;
			break;

		case 'g':
		case 'G':
			cout << "Enter their new glicko number (currently:" << glicko << ")" << endl;
			cin >> glicko;
			break;

		case 'P':
		case 'p':
			cout << "Enter their new prestige (currently:" << prestige << ")" << endl;
			cin >> prestige;
			break;

		case 'L':
		case 'l':
			cout << "Enter their new lifetime prestige (currently:" << lifetime << ")" << endl;
			cin >> lifetime;
			break;

		case 'N':
		case 'n':
			cout << "Enter their new character name (currently:";
			for (i = 0; i < namelen; i++) {
				cout << captname[i];
			}
			cout << ")" << endl;
			cin.getline(newline, 255); // to get rid of buffer garbage
			cin.getline(newline, 255);
			difference = namelen;
			namelen = strlen(newline);
			difference = namelen - difference;
			size1 += difference;
			size2 += difference;
			for (i = 0; i < namelen; i++) {
				captname[i] = newline[i];
			}
			break;

		case 'E':
		case 'e':
			cout << "Enter their new email address (currently:";
			for (i = 0; i < emaillen; i++) {
				cout << emailaddr[i];
			}
			cout << ")" << endl;
			cin.getline(newline, 255); // to get rid of buffer garbage
			cin.getline(newline, 255);
			difference = emaillen;
			emaillen = strlen(newline);
			difference = emaillen - difference;
			size1 += difference;
			size2 += difference;
			for (i = 0; i < emaillen; i++) {
				emailaddr[i] = newline[i];
			}
			break;

		case 'H':
		case 'h':
			cout << "Enter the new row number (currently:" << row << ")" << endl;
			cin >> row;
			cout << "Enter the new column number (currently:" << column << ")" << endl;
			cin >> column;
			break;

		case 'S':
		case 's':
			cout << "Ending character modification, moving on to ship modification" << endl;
			return true;
			break;

		default:
			cout << "Invalid command entered, please try again" << endl;
			break;
	}
	return false;
}

void tCharacterObject::mWriteToReport(ofstream& fpout)
{
	int i, j;
	if (AIcaptain) fpout << "AI ";
	else fpout << "Human ";
	fpout << identifier << ": ";
	switch (rank) {
		case 0: fpout << "Ensign "; break;
		case 1: fpout << "Lieutenant "; break;
		case 2: fpout << "Lieutenant Commander "; break;
		case 3: fpout << "Captain "; break;
		case 4: fpout << "Commodore "; break;
		case 5: fpout << "RearAdmiral "; break;
		case 6: fpout << "Admiral "; break;
		case 7: fpout << "FleetAdmiral "; break;
		default: break;
	}
	for (i = 0; i < namelen; i++) {
		fpout.put(captname[i]);
	}
	fpout << " (";
	std::string racename = gGetRaceName(race);
	fpout << racename.c_str() << ")";
	fpout << " in hex (" << row << "," << column << ")";
	fpout << ", glicko " << glicko << ", prestige " << prestige << ", lifetime " << lifetime;
	fpout << ", missions " << missions_flown;
	fpout << ", bids in on " << numbids << " ships";
	if (!AIcaptain) {
		fpout << ", email ";
		for (i = 0; i < emaillen; i++) {
			fpout.put(emailaddr[i]);
		}
		fpout << ", IP ";
		for (i = 0; i < iplen; i++) {
			fpout.put(ipaddr[i]);
		}
	}
	fpout << ", homeworld (" << homeworld_col << "," << homeworld_row << ")";
	fpout << endl;
	for (i = 0; i < shipcount; i++) {
		fpout << "   ship " << currships[i].shipid << " ";
		for (j = 0; j < currships[i].typelen; j++) {
			fpout << currships[i].shiptype[j];
		}
		fpout << " ";
		for (j = 0; j < currships[i].namelen; j++) {
			fpout << currships[i].shipname[j];
		}
		std::string shipclass = gGetHullClass(currships[i].hullclass);
		fpout << ", class " << shipclass.c_str();
		fpout << ", bpv " << currships[i].shipbpv << endl;
	}
	fpout << "Medals: " << medals << ", flags: " << flags << endl;
	fpout << "Flags: ";
	if (flags & 2) fpout << "logged on,";
	if (flags & 4) fpout << "AI,";
	if (flags & 8) fpout << "Base AI,";
	if (flags & 16) fpout << "not playing,";
	if (flags & 32) fpout << "playing as client,";
	if (flags & 64) fpout << "playing as host,";
	if (flags & 128) fpout << "has mandatory,";
	if (flags & 256) fpout << "has trigger mission,";
	if (flags & 512) fpout << "unresolved damage,";
	if (flags & 1024) fpout << "mission AI";
	fpout << endl;
	fpout << "Character variables of unknown purpose (unknowns 1, 6):";
	fpout << unknown1 << ","  << "," << unknown6 << "?";
	fpout << endl << endl;
}
