#ifndef CHARACTEROBJECTH
#define CHARACTEROBJECTH 1

#include "commondefs.h"

class tCharacterObject {
public:
	tCharacterObject();
	tCharacterObject(ifstream& fpin, long size);
	~tCharacterObject();
	void mWriteToDB(ofstream& fpout);
	void mWriteToReport(ofstream& fpout);
	long mGetCaptainID() { return identifier; }
	long mGetNumShips() { return shipcount; }
	long mGetShipHullclass(int i) { return currships[i].hullclass; }
	bool mIsCaptainAI() { return AIcaptain; }
	bool mModifyCaptain();
	char *mGetName() { return captname; }
	void mGetShipIDs(long &num, long *ids) {
		num = shipcount;
		for (int i = 0; i < num; i++) {
			ids[i] = currships[i].shipid;
		}
	}

public:
	long size1, size2;
	long shipcount;
	struct sShipObj {
		char unknown[10];
		long shipid;
		long shipbpv;
		long hullclass;
		long typelen;
		char *shiptype; // length given by typelen
		long damageratio;
		long namelen;
		char *shipname; // length given by namelen
		long damageflags;
	};
	sShipObj *currships; // number given by shipcount
	long race;
	long prestige;

private:
	long hdrsize;
	char header[21];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	long seperator;
	char objheader[6];
	long identifier;
	long unknown1, unknown2;
	long numbids;
	struct sBidObj {
		char unknown[5];
		long bidderid;
	};
	sBidObj *currbids; // number given by numbids
	long namelen;
	char *captname; // length given by namelen
	long glicko;
	long lifetime;
	long missions_flown, battleresult;
	char unknown5[5];
	long column, row;
	long unknown6;
	char unknown7[17];
	long medals;
	long rank, missionslot, flags; 

	// the following are only present if the character is not an AI
	long emaillen;
	char *emailaddr; // length given by emaillen
	long seperator2;
	long iplen; // 0 for SP
	char *ipaddr; // length given by iplen 
	long seperator3;
	long race3; // speculative
	long homeworld_col, homeworld_row; // speculative
	char *unknown12; // the balance of the object 
	long remaininglen;
	bool AIcaptain;
	char rubbish[9];
};

#endif