#include "stdafx.h"
#include "commondefs.h"


long gGetInt32(ifstream& fpin)
{
	char c1, c2, c3, c4;
	unsigned long result = 0l;
	fpin.get(c1);
	fpin.get(c2);
	fpin.get(c3);
	fpin.get(c4);
	
	unsigned long l1 = c1 & 255ul;
	unsigned long l2 = c2 & 255ul;
	unsigned long l3 = c3 & 255ul;
	unsigned long l4 = c4 & 255ul;
	l2 = l2 << 8;
	l3 = l3 << 16;
	l4 = l4 << 24;
	result = l4 | l3 | l2 | l1;

	return result;
}

long gGetInt16(ifstream& fpin)
{
	char c1, c2;
	unsigned long result = 0ul;
	fpin.get(c1);
	fpin.get(c2);
	
	unsigned long l1 = c1 & 255;
	unsigned long l2 = c2 & 255;
	l2 = l2 << 8;
	result = l2 | l1;

	return result;
}

void gPutInt32(ofstream& fpout, long value)
{
	unsigned char c;
	for (int i = 0; i < 4; i++) {
		c= (value & 255ul);
		fpout.put(c);
		value = value >> 8;
	}
}

void gPutInt16(ofstream& fpout, long value)
{
	char c;
	for (int i = 0; i < 2; i++) {
		c= (value & 255ul);
		fpout.put(c);
		value = value >> 8;
	}
}

eMiscObjectType gGetObjectType(long length, char *hdr)
{
	if ((length == 23) && (strncmp(hdr, ".?AVtPreparedMissions@@", 21) == 0)) return kPrepObj;
	if ((length == 20) && (strncmp(hdr, ".?AVtServCharacter@@", 18) == 0)) return kCharObj;
	if ((length == 18) && (strncmp(hdr, ".?AVtAuctionItem@@", 16) == 0)) return kBidObj;
	if ((length == 16) && (strncmp(hdr, ".?AVtNewsStory@@", 14) == 0)) return kNewsObj;
	if ((length == 11) && (strncmp(hdr, ".?AVtShip@@", 9) == 0)) return kShipObj;
	return kOtherObj;
}

void gGetString(ifstream& fpin, long& len, char* &str)
{
	len = gGetInt32(fpin);

	if (len <= 0) {
		len = 0;
		str = NULL;
	} else {
		str = new char[len];
		for (int k = 0; k < len; k++) {
			fpin.get(str[k]);
		}
	}

}

void gPutString(ofstream &fpout, long len, char *str)
{
	gPutInt32(fpout, len);
	for (int i = 0; i < len; i++) {
		fpout.put(str[i]);
	}
}

bool gEAWCampaign;
bool gServerDB;

char *gCaptName;

bool gEditDB;
bool gCleanDB;
bool gGenReport;

void gInitDBType()
{
	gEAWCampaign = true;
	gServerDB = true;
	gEditDB = false;
	gCleanDB = false;
	gGenReport = false;
	gCaptName = NULL;
	cout << "Is this a single-player campaign (Y or N)?" << endl;
	char response;
	cin >> response;
	if ((response == 'Y') || (response == 'y')) gServerDB = false;
}

bool gIsEAWCampaign()
{
	return gEAWCampaign;
}

bool gIsServerDB()
{
	return gServerDB;
}

void gSetOPCampaign()
{
	gEAWCampaign = false;
}

void gSetSPDB()
{
	gServerDB = false;
}


void gSetRuntype(char t)
{
	if (t == 'R') gGenReport = true;
	else gGenReport = false;
	if (t == 'E') gEditDB = true;
	else gEditDB = false;
	if (t == 'C') gCleanDB = true;
	else gCleanDB = false;
}

bool gGetEditDB()
{
	return gEditDB;
}

bool gGetCleanDB()
{
	return gCleanDB;
}

bool gGetGenReport()
{
	return gGenReport;
}

std::string gGetRaceName(long raceid)
{
	std::string race;
	if (gIsEAWCampaign()) {
		switch (raceid) {
			case 0: race = "Federation"; break;
			case 1: race = "Klingon"; break;
			case 2: race = "Romulan"; break;
			case 3: race = "Lyran"; break;
			case 4: race = "Hydran"; break;
			case 5: race = "Gorn"; break;
			case 6: race = "ISC"; break;
			case 7: race = "Mirak"; break;
			case 8: race = "Orion"; break;
			case 9: race = "Monster"; break;
			case 10: race = "Tholian"; break;
			case 11: race = "LDR"; break;
			case 12: race = "Wyn"; break;
			case 13: race = "Jindarian"; break;
			case 14: race = "Andromedan"; break;
			case 15: race = "Neutral"; break;
			default: race = "Unknown"; break;
		}
	} else {
		switch (raceid) {
			case 0: race = "Federation"; break;
			case 1: race = "Klingon"; break;
			case 2: race = "Romulan"; break;
			case 3: race = "Lyran"; break;
			case 4: race = "Hydran"; break;
			case 5: race = "Gorn"; break;
			case 6: race = "ISC"; break;
			case 7: race = "Mirak"; break;
			case 8: race = "Orion cartel"; break;
			case 9: race = "Korgath cartel"; break;
			case 10: race = "Prime cartel"; break;
			case 11: race = "TigerHeart cartel"; break;
			case 12: race = "BeastRaiders cartel"; break;
			case 13: race = "Syndicate cartel"; break;
			case 14: race = "Wyldefire cartel"; break;
			case 15: race = "Camboro cartel"; break;
			case 16: race = "Orion (npc)"; break;
			case 17: race = "Monster"; break;
			case 18: race = "Tholian"; break;
			case 19: race = "LDR"; break;
			case 20: race = "Wyn"; break;
			case 21: race = "Jindarian"; break;
			case 22: race = "Andromedan"; break;
			case 23: race = "Neutral"; break;
			default: race = "Unknown"; break;
		}
	}
	return race;
}

std::string gGetPlanetType(long planetid)
{
	std::string planet;
	switch (planetid) {
		case 1:
		case 2:
		case 4: planet = "homeworld, "; break;
		case 8:
		case 16:
		case 32: planet = "core world, "; break;
		case 64:
		case 128:
		case 256: planet = "colony world, "; break;
		case 512:
		case 1024:
		case 2048: planet = "asteroid base,"; break;
		default: planet = "no planet, "; break;
	}
	return planet;
}

std::string gGetTerrainType(long terrainid)
{
	std::string terrain;
	if (terrainid == 0) terrain = "unknown terrain, ";
	else if (terrainid < (1 << 6)) terrain = "empty space, ";
	else if (terrainid < (1 << 12)) terrain = "asteroid, ";
	else if (terrainid < (1 << 18)) terrain = "nebula, ";
	else if (terrainid < (1 << 24)) terrain = "black hole, ";
	else if (terrainid == (1 << 24)) terrain = "dust clouds, ";
	else if (terrainid == (1 << 25)) terrain = "shipping lane, ";
	else if (terrainid == (1 << 26)) terrain = "no terrain, ";
	else terrain = "unknown terrain, ";
	return terrain;
}

std::string gGetBaseType(long baseid)
{
	std::string base;
	switch (baseid) {
		case 1: base = "starbase, "; break;
		case 2: base = "battlestation, "; break;
		case 4: base = "base station, "; break;
		case 8: base = "defsat, "; break;
		case 16: base = "listening post, "; break;
		default: base = "no base, "; break;
	}
	return base;
}

std::string gGetHullClass(long hullclass)
{
	std::string hull;
	switch (hullclass) {
		case 0: hull = "shuttle"; break;
		case 1: hull = "pseudofighter"; break;
		case 2: hull = "freighter"; break;
		case 3: hull = "frigate"; break;
		case 4: hull = "destroyer"; break;
		case 5: hull = "war destroyer"; break;
		case 6: hull = "light cruiser"; break;
		case 7: hull = "heavy cruiser"; break;
		case 8: hull = "new heavy cruiser"; break;
		case 9: hull = "heavy battlecruiser"; break;
		case 10: hull = "carrier"; break;
		case 11: hull = "dreadnought"; break;
		case 12: hull = "battleship"; break;
		case 13: hull = "listening post"; break;
		case 14: hull = "base station"; break;
		case 15: hull = "battle station"; break;
		case 16: hull = "starbase"; break;
		case 17: hull = "monster"; break;
		case 18: hull = "planet"; break;
		case 19: hull = "special"; break;
		default: hull = "unknown"; break;
	}
	return hull;
}

long gCurrentEra;

void gSetCurrentEra(long era)
{
	gCurrentEra = era;
}

long gGetCurrentEra()
{
	return gCurrentEra;
}

void gStoreCaptName(char *name, int len)
{
	if (len > 0) {
		gCaptName = new char[len + 1];
		for (int i = 0; i < len; i++) {
			gCaptName[i] = name[i];
		}
		gCaptName[len] = '\0';;
	}
}

char *gGetCaptName()
{
	return gCaptName;
}

long gPow2(long value)
{
	long result = 1;
	if (value < 1) return 1;
	for (int i = 0; i < value; i++) {
		result = result * 2;
	}
	return result;
}

long gReplaceString(char* &oldstr, long &oldlen, char *newstr)
// replace the old length-specified string with the contents of
//    the new null-terminated string (don't copy the null)
// and return the difference in lengths
//    (+ if new string is longer than old)
{
	int i;
	long difference = oldlen;
	delete oldstr;
	if (newstr == NULL) oldlen = 0;
	else {
		i = 0;
		while (newstr[i] != '\0') i++;
		oldlen = i;
	}
	oldstr = new char[oldlen];
	for (i = 0; i < oldlen; i++) {
		oldstr[i] = newstr[i];
	}
	return (oldlen - difference);
}
