#ifndef COMMONDEFSH
#define COMMONDEFSH 1

#define EDDebug 0

// The main array of objects can contain a variety of different object types,
//    these are specified in the MiscObjectType enumerated type
// and the structure of the individual array elements are given in the
//     MiscObject struct
enum eMiscObjectType { kPrepObj, kNewsObj, kCharObj, kShipObj, kBidObj, kOtherObj };



long gGetInt32(ifstream& fpin);
long gGetInt16(ifstream& fpin);
void gPutInt32(ofstream& fpout, long value);
void gPutInt16(ofstream& fpout, long value);
void gGetString(ifstream& fpin, long& len, char* &str);
void gPutString(ofstream &fpout, long len, char *str);
long gReplaceString(char* &oldstr, long &oldlen, char *newstr);

// 0 is early era, 1 is mid, 2 is late
void gSetCurrentEra(long era);
long gGetCurrentEra();

bool gIsEAWCampaign();
bool gIsServerDB();
void gSetOPCampaign();
void gSetSPDB();
void gSetRuntype(char t);
void gInitDBType();
bool gGetEditDB();
bool gGetCleanDB();
bool gGetGenReport();
long gPow2(long value);

//char *gCaptName;
void gStoreCaptName(char *name, int len);
char *gGetCaptName();

eMiscObjectType gGetObjectType(long length, char *hdr);

std::string gGetRaceName(long raceid);
std::string gGetPlanetType(long planetid);
std::string gGetTerrainType(long terrainid);
std::string gGetBaseType(long baseid);
std::string gGetHullClass(long hullclass);
#endif

