#include "stdafx.h"
#include "maphexobject.h"

tMapHexObject::tMapHexObject()
{
}

tMapHexObject::tMapHexObject(ifstream& fpin)
{
	int i;
	size1 = gGetInt32(fpin);
	size2 = gGetInt32(fpin);
	gGetString(fpin, hdrsize, header);
	seperator = gGetInt32(fpin);
	for (i = 0; i < 6; i++) {
		fpin.get(objheader[i]);
	}
	identifier = gGetInt32(fpin);
	for (i = 0; i < 9; i++) {
		fpin.get(unknown[i]);
	}
	row = gGetInt32(fpin);
	column = gGetInt32(fpin);

	/*** SEE HEADER FILE FOR DESCRIPTION OF MARKERS A THROUGH H ***/

	if (!gIsEAWCampaign()) {
		opmarkerA = gGetInt32(fpin);
		opmarkerB = gGetInt32(fpin);
		// if it's an op DB then 
		// here we find markerA, markerB
	}
	race = gGetInt32(fpin);
	if (!gIsEAWCampaign()) {
		// if it's an OP DB then 
		// here we find markerC
		opmarkerC = gGetInt32(fpin);
		cartel = gGetInt32(fpin);
		// then the cartel region
	} else {
		if (race < 8) cartel = race + 8;
		else cartel = 23;
	}
	terrain = gGetInt32(fpin);
	planet = gGetInt32(fpin);
	base = gGetInt32(fpin);
	maxecon = gGetInt32(fpin);
	currecon = gGetInt32(fpin);
	if (!gIsEAWCampaign()) {
		// if it's an OP DB then
		opmarkerD = gGetInt32(fpin);
		opmarkerE = gGetInt32(fpin);
		// here we find markerD, markerE
	}
	maxdv = gGetInt32(fpin);
	if (!gIsEAWCampaign()) {
		// if it's an OP DB then
		// here we find markerF
		opmarkerF = gGetInt32(fpin);
		cartelmaxdv = gGetInt32(fpin);
		// then the cartel max dv
		opmarkerG = gGetInt32(fpin);
		opmarkerH = gGetInt32(fpin);
		// then markerG and markerH
	} else cartelmaxdv = maxdv;
	currdv = gGetInt32(fpin);
	if (!gIsEAWCampaign()) {
		// if it's an OP DB then
		// here we find markerI
		opmarkerI = gGetInt32(fpin);
		cartelcurrdv = gGetInt32(fpin);
		// then the cartel currdv
	} else cartelcurrdv = currdv;
	maximpa = gGetInt32(fpin);
	maximpb = gGetInt32(fpin);
	currimpa = gGetInt32(fpin);
	currimpb = gGetInt32(fpin);
	remaininglen = size1 - (hdrsize + 83);
	if (!gIsEAWCampaign()) {
		// if it's an OP DB then here we
		// must subtract the extra 48 bytes
		remaininglen = remaininglen - 48;
	}
	if (remaininglen > 0) {
		unknown2 = new char[remaininglen];
		for (i = 0; i < remaininglen; i++) {
			fpin.get(unknown2[i]);
		}
	} else {
		unknown2 = NULL;
		remaininglen = 0;
	}
}

tMapHexObject::~tMapHexObject()
{
	if (EDDebug) cout << "Deleting maphex object" << endl;
	delete header;
	delete unknown2;
}

void tMapHexObject::mWriteToDB(ofstream& fpout)
{
	int i;
	gPutInt32(fpout, size1);
	gPutInt32(fpout, size2);
	gPutString(fpout, hdrsize, header);
	gPutInt32(fpout, seperator);
	for (i = 0; i < 6; i++) {
		fpout.put(objheader[i]);
	}
	gPutInt32(fpout, identifier);
	for (i = 0; i < 9; i++) {
		fpout.put(unknown[i]);
	}
	gPutInt32(fpout, row);
	gPutInt32(fpout, column);
	if (!gIsEAWCampaign()) {
		// if it's an op DB then 
		// here we find markerA, markerB
		gPutInt32(fpout, opmarkerA);
		gPutInt32(fpout, opmarkerB);
	}
	gPutInt32(fpout, race);
	if (!gIsEAWCampaign()) {
		// if it's an OP DB then 
		// here we find markerC
		gPutInt32(fpout, opmarkerC);
		gPutInt32(fpout, cartel);
		// then the cartel region
	}
	gPutInt32(fpout, terrain);
	gPutInt32(fpout, planet);
	gPutInt32(fpout, base);
	gPutInt32(fpout, maxecon);
	gPutInt32(fpout, currecon);
	if (!gIsEAWCampaign()) {
		// if it's an OP DB then
		// here we find markerD, markerE
		gPutInt32(fpout, opmarkerD);
		gPutInt32(fpout, opmarkerE);
	}
	gPutInt32(fpout, maxdv);
	if (!gIsEAWCampaign()) {
		// if it's an OP DB then
		// here we find markerF
		gPutInt32(fpout, opmarkerF);
		// then the cartel max dv
		gPutInt32(fpout, cartelmaxdv);
		// then markerG and markerH
		gPutInt32(fpout, opmarkerG);
		gPutInt32(fpout, opmarkerH);
	}
	gPutInt32(fpout, currdv);
	if (!gIsEAWCampaign()) {
		// if it's an OP DB then
		// here we find markerI
		gPutInt32(fpout, opmarkerI);
		gPutInt32(fpout, cartelcurrdv);
		// then the cartel currdv
	}
	gPutInt32(fpout, maximpa);
	gPutInt32(fpout, maximpb);
	gPutInt32(fpout, currimpa);
	gPutInt32(fpout, currimpb);
	for (i = 0; i < remaininglen; i++) {
		fpout.put(unknown2[i]);
	}
}
	
void tMapHexObject::mModifyHex(char adjust_type, long adjust_amt, long restrict_type, long restrict_amt)
{
	// to be done
}

void tMapHexObject::mWriteToReport(ofstream& fpout)
{
	std::string racename = gGetRaceName(race);
	fpout << racename.c_str();
	fpout << " hex (" << row << "," << column << ") ";
	fpout << "DV " << currdv << "/" << maxdv << ", ";
	if (!gIsEAWCampaign()) {
		fpout << " cartel: ";
		racename = gGetRaceName(cartel);
		fpout << racename.c_str();
		fpout << ", DV ";
		fpout << cartelcurrdv << "/" << cartelmaxdv << endl << "   ";
	}
	fpout << "Econ " << currecon << "/" << maxecon << ", contents: ";
	/*
	Impedence values:
	"real" value  part a hex   part b hex
	1.0           00 00 00 00  00 00 F0 3F
	0.7           66 66 66 66  66 66 E6 3F
	*/
	std::string basetype = gGetBaseType(base);
	fpout << basetype.c_str();
	std::string planettype = gGetPlanetType(planet);
	fpout << planettype.c_str();
	std::string terraintype = gGetTerrainType(terrain);
	fpout << terraintype.c_str() << endl;

}



void tMapHexObject::mModifyHex()
{
	std::string racename = gGetRaceName(race);
	std::string basetype = gGetBaseType(base);
	std::string planettype = gGetPlanetType(planet);
	std::string terraintype = gGetTerrainType(terrain);
	std::string cartelname = gGetRaceName(cartel);

	cout << "Modifying map hex (" << row << "," << column << ")" << endl;
	cout << "Enter R to set the owning race and cartel (current:" << racename.c_str() << ", ";
	cout << cartelname.c_str() << ")" << endl;
	cout << "   or B to set the type of base (current:" << basetype.c_str() << ")" << endl;
	cout << "   or P to set the type of planet (current:" << planettype.c_str() << ")" << endl;
	cout << "   or T to set the type of terrain (current:" << terraintype.c_str() << ")" << endl;
	cout << "   or D to set the maximum defensive value (current:" << maxdv << ")" << endl;
	cout << "   or d to set the current defensive value (current:" << currdv << ")"<< endl;
	cout << "   or E to set the maximum economic value (current:" << maxecon << ")"<< endl;
	cout << "   or e to set the current economic value (current:" << currecon << ")"<< endl;
	cout << "   or C to cancel" << endl << endl;
	cout << "WARNING: there is no error checking, and no UNDO, so BE CAREFUL!" << endl;
	char cmd;
	cin >> cmd;
	switch (cmd) {
		case 'R':
			cout << "Pick the new owning race:" << endl;
			cout << "F, K, R, L, H, G, I, Z, or N" << endl;
			char rtype;
			cin >> rtype;
			if (rtype == 'F') race = 0;
			else if (rtype == 'K') race = 1;
			else if (rtype == 'R') race = 2;
			else if (rtype == 'L') race = 3;
			else if (rtype == 'H') race = 4;
			else if (rtype == 'G') race = 5;
			else if (rtype == 'I') race = 6;
			else if (rtype == 'Z') race = 7;
			else if (rtype == 'N') {
				if (gIsEAWCampaign()) race = 15;
				else race = 23;
			}
			if (!gIsEAWCampaign()) {
				cout << "Pick the new local cartel:" << endl;
				cout << "X, Y, P, T, B, S, W, C, or N" << endl;
				char cartype;
				cin >> cartype;
				if (cartype == 'X') cartel = 8;
				else if (cartype == 'Y') cartel = 9;
				else if (cartype == 'R') cartel = 10;
				else if (cartype == 'L') cartel = 11;
				else if (cartype == 'H') cartel = 12;
				else if (cartype == 'G') cartel = 13;
				else if (cartype == 'I') cartel = 14;
				else if (cartype == 'Z') cartel = 15;
				else if (cartype == 'N') cartel = 23;
			} 
			break;

		case 'B':
			cout << "Pick the new base type:" << endl;
			cout << "1 for LP, 2 for DefSat, 3 for base, 4 for Bats, 5 for SB" << endl;
			cout << "or any other value for no base" << endl;
			int btype;
			cin >> btype;
			if (btype == 1) base = 16;
			else if (btype == 2) base = 8;
			else if (btype == 3) base = 4;
			else if (btype == 4) base = 2;
			else if (btype == 5) base = 1;
			else base = 0;
			break;

		case 'P':
			cout << "Pick the new planet type:" << endl;
			cout << "0, 1, or 2 for homeworld" << endl;
			cout << "3, 4, or 5 for core world" << endl;
			cout << "6, 7, or 8 for colony" << endl;
			cout << "or anything else for no planet" << endl;
			int ptype;
			cin >> ptype;
			if ((ptype > 0) && (ptype < 10)) {
				planet = gPow2(ptype);
			} else planet = 0;
			break;

		case 'T':
			cout << "Pick the new terrain type (there are multiple variants for most types):" << endl;
			cout << "Enter 0..5 for empty space" << endl;
			cout << "   or 6..11 for asteroids" << endl;
			cout << "   or 12..17 for nebulae" << endl;
			cout << "   or 18..23 for black holes" << endl;
			cout << "   or 24 for dust clouds" << endl;
			cout << "   or 25 for shipping lane" << endl;
			int ttype;
			cin >> ttype;
			if ((ttype > 0) && (ttype < 27)) {
				terrain = (1 << ttype);
			}
			break;

		case 'D': 
			cout << "Please enter the new maximum defensive value" << endl;
			cin >> maxdv;
			break;

		case 'd': 
			cout << "Please enter the new current defensive value" << endl;
			cin >> currdv;
			break;

		case 'E': 
			cout << "Please enter the new maximum defensive value" << endl;
			cin >> maxecon;
			break;

		case 'e': 
			cout << "Please enter the new current economic value" << endl;
			cin >> currecon;
			break;

		case 'C': 
			cout << "Cancelling hex modification" << endl;
			break;

		default: 
			cout << "An invalid command was entered: " << cmd << endl;
			cout << "Please try again" << endl << endl;
			mModifyHex();
			break;
	}
}
