#include "stdafx.h"
#include "mapobject.h"

tMapObject::tMapObject()
{
}

tMapObject::tMapObject(ifstream& fpin)
{
	int i;
	header = NULL;
	unknown2 = NULL;
	size1 = gGetInt32(fpin);
	size2 = gGetInt32(fpin);
	gGetString(fpin, hdrlen, header);
	seperator = gGetInt32(fpin);
	for (i = 0; i < 6; i++) {
		fpin.get(objheader[i]);
	}
	identifier = gGetInt32(fpin);
	unknown1 = gGetInt32(fpin);
	numcolumns = gGetInt32(fpin);
	numrows = gGetInt32(fpin);
	remaininglen = size1 - (30 + hdrlen);
	if (remaininglen > 0) {
		unknown2 = new char[remaininglen];
		for (i = 0; i < remaininglen; i++) {
			fpin.get(unknown2[i]);
		}
	} else {
		remaininglen = 0;
		unknown2 = NULL;
	}
	numhexes = numcolumns * numrows;
}

tMapObject::~tMapObject()
{
	if (EDDebug) cout << "Deleting map object" << endl;
}

tMapObject::mWriteToDB(ofstream& fpout)
{
	int i;
	gPutInt32(fpout, size1);
	gPutInt32(fpout, size2);
	gPutString(fpout, hdrlen, header);
	gPutInt32(fpout, seperator);
	for (i = 0; i < 6; i++) {
		fpout.put(objheader[i]);
	}
	gPutInt32(fpout, identifier);
	gPutInt32(fpout, unknown1);
	gPutInt32(fpout, numcolumns);
	gPutInt32(fpout, numrows);
	if (remaininglen > 0) {
		for (i = 0; i < remaininglen; i++) {
			fpout.put(unknown2[i]);
		}
	}
}

tMapObject::mWriteToReport(ofstream& fpout)
{
	fpout << endl;
	fpout << "Map size " << numhexes << " hexes: " << numcolumns << " columns by ";
	fpout << numrows << " rows" << endl;
	fpout << "Map variable(s) of unknown purpose (unknown1): " << unknown1;
	fpout << endl << endl;
}
