#include "stdafx.h"
#include "newsobject.h"

tNewsObject::tNewsObject()
{
}

tNewsObject::tNewsObject(ifstream& fpin, long size)
{
	// data fields, in order they appear in the database,
	// long size1, size2;
	// long hdrsize;
	// long header[16];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	// long seperator;
	// char objheader[6];
	// long identifier;
	// long seperator2;
	// char unknown[3];
	// long newslen;
	// char *newsstr; // length is given by newslen
	// char *unknown2; // length is balance of object size
	int i;
	size1 = size;
	size2 = size;
	hdrsize = 16;
	strncpy(header, ".?AVtNewsStory@@", 16);
	seperator = gGetInt32(fpin);
	for (i = 0; i < 6; i++) {
		fpin.get(objheader[i]);
	}
	identifier = gGetInt32(fpin);
	seperator2 = gGetInt32(fpin);
	for (i = 0; i < 3; i++) {
		fpin.get(unknown[i]);
	}
	gGetString(fpin, newslen, newsstr);
	remaininglen = size1 - (newslen + hdrsize + 29);
	if (remaininglen > 0) {
		unknown2 = new char[remaininglen];
		for (i = 0; i < remaininglen; i++) {
			fpin.get(unknown2[i]);
		}
	} else {
		remaininglen = 0;
		unknown2 = NULL;
	}
}

tNewsObject::~tNewsObject()
{
	if (EDDebug) cout << "Deleting news object" << endl;
	delete newsstr;
	delete unknown2;
}

tNewsObject::mWriteToDB(ofstream& fpout)
{
	// data fields, in order they appear in the database,
	// long size1, size2;
	// long hdrsize;
	// long header[16];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	// long seperator;
	// char objheader[6];
	// long identifier;
	// long seperator2;
	// char unknown[3];
	// long newslen;
	// char *newsstr; // length is given by newslen
	// char *unknown2; // length is balance of object size
	int i;
	gPutInt32(fpout, size1);
	gPutInt32(fpout, size2);
	gPutString(fpout, hdrsize, header);
	gPutInt32(fpout, seperator);
	for (i = 0; i < 6; i++) {
		fpout.put(objheader[i]);
	}
	gPutInt32(fpout, identifier);
	gPutInt32(fpout, seperator2);
	for (i = 0; i < 3; i++) {
		fpout.put(unknown[i]);
	}
	gPutString(fpout, newslen, newsstr);
	for (i = 0; i < remaininglen; i++) {
		fpout.put(unknown2[i]);
	}
}

tNewsObject::mWriteToReport(ofstream& fpout)
{
	int i;
	fpout << "News story: ";
	for (i = 0; i < newslen; i++) {
		fpout.put(newsstr[i]);
	}
	fpout << endl << endl;
}

tPrepObject::tPrepObject()
{
}

tPrepObject::tPrepObject(ifstream& fpin, long size)
{
	// data fields, in order they appear in the database,
	// long size1, size2;
	// long hdrsize;
	// long header[16];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	// long seperator;
	// char objheader[6];
	// long identifier;
	// long seperator2;
	// char unknown[3];
	// char *unknown2; // length is balance of object size
	int i;
	size1 = size;
	size2 = size;
	hdrsize = 21;
	strncpy(header, ".?AVtPreparedMissions@@", 21);
	seperator = gGetInt32(fpin);
	for (i = 0; i < 6; i++) {
		fpin.get(objheader[i]);
	}
	identifier = gGetInt32(fpin);
	remaininglen = size1 - (hdrsize + 18);
	if (remaininglen > 0) {
		unknown2 = new char[remaininglen];
		for (i = 0; i < remaininglen; i++) {
			fpin.get(unknown2[i]);
		}
	} else {
		remaininglen = 0;
		unknown2 = NULL;
	}
}

tPrepObject::~tPrepObject()
{
	if (EDDebug) cout << "Deleting prep object" << endl;
	// delete unknown2;
}

tPrepObject::mWriteToDB(ofstream& fpout)
{
	// data fields, in order they appear in the database,
	// long size1, size2;
	// long hdrsize;
	// long header[16];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	// long seperator;
	// char objheader[6];
	// long identifier;
	// long seperator2;
	// char unknown[3];
	// char *unknown2; // length is balance of object size
	int i;
	gPutInt32(fpout, size1);
	gPutInt32(fpout, size2);
	gPutString(fpout, hdrsize, header);
	gPutInt32(fpout, seperator);
	for (i = 0; i < 6; i++) {
		fpout.put(objheader[i]);
	}
	gPutInt32(fpout, identifier);
	for (i = 0; i < remaininglen; i++) {
		fpout.put(unknown2[i]);
	}
}

tPrepObject::mWriteToReport(ofstream& fpout)
{
	fpout << "Prepared Missions List ";
	fpout << endl << endl;
}
