#ifndef NEWSOBJECTH
#define NEWSOBJECTH 1

#include "commondefs.h"

class tNewsObject {
public:
	tNewsObject();
	tNewsObject(ifstream& fpin, long size);
	~tNewsObject();
	mWriteToDB(ofstream& fpout);
	mWriteToReport(ofstream& fpout);
	long mGetNewsID() { return identifier; }
private:
	// data fields, in order they appear in the database,
	long size1, size2;
	long hdrsize;
	char header[17];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	long seperator;
	char objheader[6];
	long identifier;
	long seperator2;
	char unknown[3];
	long newslen;
	char *newsstr; // length is given by newslen
	char *unknown2; // length is balance of object size
	long remaininglen;
};

class tPrepObject {
public:
	tPrepObject();
	tPrepObject(ifstream& fpin, long size);
	~tPrepObject();
	mWriteToDB(ofstream& fpout);
	mWriteToReport(ofstream& fpout);
	long mGetPrepID() { return identifier; }
private:
	// data fields, in order they appear in the database,
	long size1, size2;
	long hdrsize;
	char header[22];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	long seperator;
	char objheader[6];
	long identifier;

	char *unknown2; // length is balance of object size
	long remaininglen;
	// known to include
	// - the id of the player
	// - a vector of missions offered
	// - a bool indicating if one is a trigger mission
	// - a vector of nearby characters who could be drafted
	// - a vector of their ids
	// - the number of human players
	// - the row and column
};

#endif