#include "stdafx.h"
#include "politicalobject.h"

tPoliticalObject::tPoliticalObject()
{
}

tPoliticalObject::tPoliticalObject(ifstream& fpin)
{
	int i, j;
	header = NULL;
	tensions = NULL;
	unknown2 = NULL;
	objsize1 = gGetInt32(fpin);
	objsize2 = gGetInt32(fpin);
	gGetString(fpin, hdrlength, header);
	seperator = gGetInt32(fpin);
	for (i = 0; i < 6; i++) {
		fpin.get(objheader[i]);
	}
	identifier = gGetInt32(fpin);
	unknown1 = gGetInt32(fpin);
	numraces = gGetInt32(fpin);
	if (numraces > 0) {
		tensions = new sTensionElem[numraces * numraces];
		int index = 0;
		for (i = 0; i < numraces; i++) {
			for (j = 0; j < numraces; j++) {
				tensions[index].tension = gGetInt16(fpin);
				fpin.get(tensions[index].percent);
				index++;
			}
		}
	} else {
		numraces = 0;
		tensions = NULL;
	}
	fpin.get(allyratio);
	fpin.get(neutralratio);
	remaininglen = objsize1 - (hdrlength + 28);
	remaininglen = remaininglen - (3 * numraces * numraces);
	if (remaininglen > 0) {
		unknown2 = new char[remaininglen];
		for (i = 0; i < remaininglen; i++) {
			fpin.get(unknown2[i]);
		}
	} else {
		remaininglen = 0;
		unknown2 = NULL;
	}
}

tPoliticalObject::~tPoliticalObject()
{
	if (EDDebug) cout << "Deleting political object" << endl;
}

void tPoliticalObject::mWriteToDB(ofstream& fpout)
{
	int i, j;
	gPutInt32(fpout, objsize1);
	gPutInt32(fpout, objsize2);
	gPutString(fpout, hdrlength, header);
	gPutInt32(fpout, seperator);
	for (i = 0; i < 6; i++) {
		fpout.put(objheader[i]);
	}
	gPutInt32(fpout, identifier);
	gPutInt32(fpout, unknown1);
	gPutInt32(fpout, numraces);
	int index = 0;
	for (i = 0; i < numraces; i++) {
		for (j = 0; j < numraces; j++) {
			gPutInt16(fpout, tensions[index].tension);
			fpout.put(tensions[index].percent);
			index++;
		}
	}
	fpout.put(allyratio);
	fpout.put(neutralratio);
	for (i = 0; i < remaininglen; i++) {
		fpout.put(unknown2[i]);
	}
}

void tPoliticalObject::mWriteToReport(ofstream& fpout)
{
	long row, col;
	fpout << endl;
	fpout << "Political tension matrix:" << endl;
	fpout << "=========================" << endl;
	int racelimit = 10;
	if (!gIsEAWCampaign()) racelimit = 18;
	for (col = 0; col < racelimit; col++) {
		std::string keyrace = gGetRaceName(col);
		fpout << keyrace.c_str() << " tensions" << endl;
		for (row = 0; row < racelimit; row++) {
			std::string opprace = gGetRaceName(row);
			int index = col * numraces + row;
			fpout << "   vs " << opprace.c_str() << ": ";
			fpout << tensions[index].tension << endl;
		}
		fpout << endl;
	}
	fpout << endl;
	fpout << "Ally ratio (0-100): " << (int)(allyratio) << endl;
	fpout << "Neutral ratio (0-100): " << (int)(neutralratio) << endl;
}

long tPoliticalObject::mGetRaceNum()
{
	cout << "Enter the race whose tension you wish to modify:" << endl;
	cout << "Enter 0 for Federation" << endl;
	cout << "   or 1 for Klingon" << endl;
	cout << "   or 2 for Romulan" << endl;
	cout << "   or 3 for Lyran" << endl;
	cout << "   or 4 for Hydran" << endl;
	cout << "   or 5 for Gorn" << endl;
	cout << "   or 6 for ISC" << endl;
	cout << "   or 7 for Mirak" << endl;
	if (!gIsEAWCampaign()) {
		// add OP races here
		cout << "   or 8 for Rogue Orion" << endl;
		cout << "   or 9 for Orion Cartel" << endl;
		cout << "   or 10 for Korgath" << endl;
		cout << "   or 11 for Prime" << endl;
		cout << "   or 12 for Tigerheart" << endl;
		cout << "   or 13 for Beastraiders" << endl;
		cout << "   or 14 for Syndicate" << endl;
		cout << "   or 15 for Wyldefire" << endl;
		cout << "   or 16 for Camboro" << endl;
		cout << "   or 17 for Monster" << endl;
		cout << "   or 18 for Neutral" << endl;
	} else {
		cout << "   or 8 for Orion" << endl;
		cout << "   or 9 for Monster" << endl;
		cout << "   or 15 for Neutral" << endl;
	}
	long result;
	cin >> result;
	return result;
}

void tPoliticalObject::mModifyTensions()
{
	cout << endl << "EDITING POLITICAL TENSIONS" << endl;
	long race1, race2;
	cout << endl << "Enter the race whose attitude you wish to change" << endl;
	race1 = mGetRaceNum();
	cout << endl << "Now enter the other race" << endl;
	race2 = mGetRaceNum();
	long index = race2 + (race1 * numraces);
	cout << endl << "Now enter the new tension level, 0..1000" << endl;
	cout << "(0 means allies, 1000 means hated enemies)" << endl;
	cin >> tensions[index].tension;
	tensions[index].percent = (unsigned char)(tensions[index].tension / 10);
	cout << "Enter the new ally ratio (0..100), represents tension percent below which races are allies" << endl;
	unsigned short ratio;
	cin >> ratio;
	allyratio = ratio;
	cout << "Enter the new neutral ratio (0..100), roughly represents tension percent above which races are enemies" << endl;
	cin >> ratio;
	neutralratio = ratio;
}
