#include "stdafx.h"
#include "shipobject.h"

tShipObject::tShipObject()
{
}

tShipObject::tShipObject(ifstream& fpin, long size)
{
	int i;
	shipedited = false;
	size1 = size;
	size2 = size;
	hdrsize = 11;
	strncpy(header, ".?AVtShip@@", 11);
	seperator = gGetInt32(fpin);
	for (i = 0; i < 6; i++) {
		fpin.get(objheader[i]);
	}
	identifier = gGetInt32(fpin);
	seperator2 = gGetInt32(fpin);
	for (i = 0; i < 5; i++) {
		fpin.get(unknown[i]);
	}
	captainid = gGetInt32(fpin);
	fpin.get(auctionflag);
	race = gGetInt32(fpin);
	hullclass = gGetInt32(fpin);
	shipbpv1 = gGetInt32(fpin);
	shipepv = gGetInt32(fpin);
	gGetString(fpin, typelen, typestr);
	gGetString(fpin, namelen, namestr);
	for (i = 0; i < 449; i++) {
		fpin.get(shipstate[i]);
		// this includes all the ship stores information,
		// as well as information on damage to the ship:
		// first there are 9 unknown characters
		// then the total RW and current RW
		// then the total LW and current LW
		// then the total CW and current CW
		// then the total impulse and current impulse
		// then the total APR and current APR
		// then the total bridge and current bridge
		// then the total sensor and current sensor
		// then the total scanner and current scanner
		// then the total damage control and current damage control
		// then the total repair and current repair
		// then the total fwd hull and current fwd hull
		// then the total aft hull and current aft hull
		// then the total ctr hull and current ctr hull
		// then the total tractors and current tractors
		// then the total excess dam and current excess dam
		// then the total transporters and current transporters
		// then the two transporter values repeated ??? (unsure)
		// then the total btty and current btty
		// then the total lab and current lab
		// then the total cargo and current cargo
		// then the total armour and current armour
		// then the toal barracks and current barracks
		// then an unknown, could be dam con or excess dam again?
		// then the total probes and current probes
		// then the number of barracks
		// then 25 pairs corresponding to each of
		//     the 25 possible hardpoints: with total and current for each
		// then there are 47 unknown characters
		// then there is the type of drones (0 = I, 3 = IV)
		// then there is the drone speed (0, 1, or 2)
		// then there is the # of reloads
		// then there are 225 unknown characterss
		// then there is the maximum number of shuttles
		// then there is the current number of shuttles
		// then there are 13 unknown characters
		// the next 100 are FF's
	}
	lwarptot = shipstate[9];
	lwarpcurr = shipstate[10];
	rwarptot = shipstate[11];
	rwarpcurr = shipstate[12];
	cwarptot = shipstate[13];
	cwarpcurr = shipstate[14];
	impulsetot = shipstate[15];
	impulsecurr = shipstate[16];
	aprtot = shipstate[17];
	aprcurr = shipstate[18];
	bridgetot = shipstate[19];
	bridgecurr = shipstate[20];
	sensortot = shipstate[21];
	sensorcurr = shipstate[22];
	scannertot = shipstate[23];
	scannercurr = shipstate[24];
	damcontot = shipstate[25];
	damconcurr = shipstate[26];
	repairtot = shipstate[27];
	repaircurr = shipstate[28];
	fhulltot = shipstate[29];
	fhullcurr = shipstate[30];
	ahulltot = shipstate[31];
	ahullcurr = shipstate[32];
	chulltot = shipstate[33];
	chullcurr = shipstate[34];
	tractot = shipstate[35];
	traccurr = shipstate[36];
	excesstot = shipstate[37];
	excesscurr = shipstate[38];
	transtot = shipstate[39];
	transcurr = shipstate[40];
	shuttot = shipstate[41];
	shutcurr = shipstate[42];
	bttytot = shipstate[43];
	bttycurr = shipstate[44];
	labtot = shipstate[45];
	labcurr = shipstate[46];
	cargotot = shipstate[47];
	cargocurr = shipstate[48];
	armourtot = shipstate[49];
	armourcurr = shipstate[50];
	cloaktot = shipstate[51];
	cloakcurr = shipstate[52];
	damcongrptot = shipstate[53];
	damcongrpcurr = shipstate[54];
	probetot = shipstate[55];
	probecurr = shipstate[56];
	barrackstot = shipstate[57];
	barrackscurr = shipstate[58];
	weaponstot = 0;
	weaponscurr = 0;
	for (i = 0; i < 25; i++) {
		weaponstot += shipstate[59 + (2*i)];
		weaponscurr += shipstate[60 + (2*i)];
	}

	/*
	char scrtytot, scrtycurr;
		// total weapons and current weapons in next 25 pairs
	char weaponstot, weaponscurr;
	*/
	// drone info
	dronetype = shipstate[121];
	dronespeed = shipstate[122];
	dronereloads = shipstate[123];
	droneracks = shipstate[125];
	maxdrones = shipstate[127];
	dronesready = shipstate[129];
	currdrones = shipstate[131];
	char racksprocessed = 0;
	int offset = 133;
	numhardpoints = 0;
	while ((racksprocessed < droneracks) && (offset < 323)) {
		if (shipstate[offset+4] > 0) {
			readydrones_hp[numhardpoints] = shipstate[offset];
			racksprocessed += shipstate[offset+4];
			currdrones_hp[numhardpoints] = shipstate[offset+2];
			numracks_hp[numhardpoints] = shipstate[offset+4];
			racksize_hp[numhardpoints] = shipstate[offset+6];
			dataoffset_hp[numhardpoints] = offset+2;
			numhardpoints++;
		}
		offset += 8;
	}
	shuttlesbase = shipstate[333];
	shuttlesmax = shipstate[334];
	shuttlescur = shipstate[335];

	// 336-345 should all be 0's, for different shuttle types from sfc1
	// at 345 we should get a 0 long for transporter items,
	// then we should get a 100 byte vector of -1's,

	fpin.get(marinesmax);
	fpin.get(marinesbase);
	fpin.get(marinescur);
	fpin.get(tbombsmax);
	fpin.get(tbombsbase);
	fpin.get(tbombscur);
	fpin.get(sparesmax);
	fpin.get(sparesbase);
	fpin.get(sparescur);

	remaininglen = size - (namelen + typelen + 525);

	// next collect the info on all the fighter bays,
	// curr/max/default number of fighters in the bay (and 1 byte seperator)
	// plus the length/name of the actual and default fighter types for that bay
	for (i = 0; i < 4; i++) {
		fpin.get(fighterbays[i].currnum);
		fpin.get(fighterbays[i].maxnum);
		fpin.get(fighterbays[i].defnum);
		fpin.get(fighterbays[i].ftrsep);
		gGetString(fpin, fighterbays[i].act_size, fighterbays[i].act_ftr);
		gGetString(fpin, fighterbays[i].def_size, fighterbays[i].default_ftr);
		remaininglen = remaininglen - (12 + fighterbays[i].act_size + fighterbays[i].def_size);
	}

	if (remaininglen > 0) {
		// this remaining segment should contain 7 zeroed officer entries,
		restofdesc = new char[remaininglen];
		for (i = 0; i < remaininglen; i++) {
			fpin.get(restofdesc[i]);
		}
	} else {
		remaininglen = 0;
		restofdesc = NULL;
	}
}

tShipObject::~tShipObject()
{
	if (EDDebug) cout << "Deleting ship object" << endl;
	delete typestr;
	delete namestr;
	delete restofdesc;
}

tShipObject::mWriteToDB(ofstream& fpout)
{
	int i;

	if (shipedited) {
		shipedited = false;
		//	Process any editing changes to the ship SSD
		shipstate[9] = rwarptot;
		shipstate[10] = rwarpcurr;
		shipstate[11] = lwarptot;
		shipstate[12] = lwarpcurr;
		shipstate[13] = cwarptot;
		shipstate[14] = cwarpcurr;
		shipstate[15] = impulsetot;
		shipstate[16] = impulsecurr;
		shipstate[17] = aprtot;
		shipstate[18] = aprcurr;
		shipstate[19] = bridgetot;
		shipstate[20] = bridgecurr;
		shipstate[21] = sensortot;
		shipstate[22] = sensorcurr;
		shipstate[23] = scannertot;
		shipstate[24] = scannercurr;
		shipstate[25] = damcontot;
		shipstate[26] = damconcurr;
		shipstate[27] = repairtot;
		shipstate[28] = repaircurr;
		shipstate[29] = fhulltot;
		shipstate[30] = fhullcurr;
		shipstate[31] = ahulltot;
		shipstate[32] = ahullcurr;
		shipstate[33] = chulltot;
		shipstate[34] = chullcurr;
		shipstate[35] = tractot;
		shipstate[36] = traccurr;
		shipstate[37] = excesstot;
		shipstate[38] = excesscurr;
		shipstate[39] = transtot;
		shipstate[40] = transcurr;
		shipstate[41] = shuttot;
		shipstate[42] = shutcurr;
		shipstate[43] = bttytot;
		shipstate[44] = bttycurr;
		shipstate[45] = labtot;
		shipstate[46] = labcurr;
		shipstate[47] = cargotot;
		shipstate[48] = cargocurr;
		shipstate[49] = armourtot;
		shipstate[50] = armourcurr;
		shipstate[51] = cloaktot;
		shipstate[52] = cloakcurr;
		shipstate[53] = damcongrptot;
		shipstate[54] = damcongrpcurr;
		shipstate[55] = probetot;
		shipstate[56] = probecurr;
		shipstate[57] = barrackstot;
		shipstate[58] = barrackscurr;
		for (i = 0; i < 25; i++) {
			weaponstot += shipstate[59 + (2*i)];
			weaponscurr += shipstate[60 + (2*i)];
		}
		shipstate[333] = shuttlesbase;
		shipstate[334] = shuttlesmax;
		shipstate[335] = shuttlescur;
		// drone info
		shipstate[121] = dronetype;
		shipstate[122] = dronespeed;
		shipstate[123] = dronereloads;
		shipstate[125] = droneracks;
		shipstate[127] = maxdrones;
		shipstate[131] = currdrones;
		int offset;
		for (i = 0; i < numhardpoints; i++) {
			offset = dataoffset_hp[i];
			shipstate[offset] = currdrones_hp[i];
			shipstate[offset+2] = numracks_hp[i];
			shipstate[offset+4] = racksize_hp[i];
		}
	}

	// Now write out the up to date information
	gPutInt32(fpout, size1);
	gPutInt32(fpout, size2);
	gPutString(fpout, hdrsize, header);
	gPutInt32(fpout, seperator);
	for (i = 0; i < 6; i++) {
		fpout.put(objheader[i]);
	}
	gPutInt32(fpout, identifier);
	gPutInt32(fpout, seperator2);
	for (i = 0; i < 5; i++) {
		fpout.put(unknown[i]); 
	}
	gPutInt32(fpout, captainid);
	fpout.put(auctionflag);
	gPutInt32(fpout, race);
	gPutInt32(fpout, hullclass);
	gPutInt32(fpout, shipbpv1);
	gPutInt32(fpout, shipepv);
	gPutString(fpout, typelen, typestr);
	gPutString(fpout, namelen, namestr);
	for (i = 0; i < 449; i++) {
		fpout.put(shipstate[i]);
	}
	fpout.put(marinesmax);
	fpout.put(marinesbase);
	fpout.put(marinescur);
	fpout.put(tbombsmax);
	fpout.put(tbombsbase);
	fpout.put(tbombscur);
	fpout.put(sparesmax);
	fpout.put(sparesbase);
	fpout.put(sparescur);
	for (i = 0; i < 4; i++) {
		fpout.put(fighterbays[i].currnum);
		fpout.put(fighterbays[i].maxnum);
		fpout.put(fighterbays[i].defnum);
		fpout.put(fighterbays[i].ftrsep);
		gPutString(fpout, fighterbays[i].act_size, fighterbays[i].act_ftr);
		gPutString(fpout, fighterbays[i].def_size, fighterbays[i].default_ftr);
	}
	for (i = 0; i < remaininglen; i++) {
		fpout.put(restofdesc[i]);
	}
}

tShipObject::mWriteToReport(ofstream& fpout)
{
	int i, j;
	if (captainid == 0) fpout << "Shipyard vessel ";
	else fpout << "Ship ";
	fpout << identifier << ":";
	for (i = 0; i < typelen; i++) {
		fpout.put(typestr[i]);
	}
	fpout << ", ";
	for (i = 0; i < namelen; i++) {
		fpout.put(namestr[i]);
	}
	std::string shipclass = gGetHullClass(hullclass);
	fpout << ", bpv " << shipbpv1 << ", class " << shipclass.c_str() << ", race " ;
	std::string racename = gGetRaceName(race);
	fpout << racename.c_str();
	if (captainid != 0) fpout << ", captained by " << captainid;
	int fldcnt = 10;
	mWrtRepCh(fpout, rwarpcurr, rwarptot, "r. warp", fldcnt);
	mWrtRepCh(fpout, lwarpcurr, lwarptot, "l. warp", fldcnt);
	mWrtRepCh(fpout, cwarpcurr, cwarptot, "c. warp", fldcnt);
	mWrtRepCh(fpout, impulsecurr, impulsetot, "impulse", fldcnt);
	mWrtRepCh(fpout, aprcurr, aprtot, "apr", fldcnt);
	mWrtRepCh(fpout, bridgecurr, bridgetot, "bridge", fldcnt);
	mWrtRepCh(fpout, sensorcurr, sensortot, "sensor", fldcnt);
	mWrtRepCh(fpout, scannercurr, scannertot, "scanner", fldcnt);
	mWrtRepCh(fpout, damconcurr, damcontot, "dam ctrl", fldcnt);
	mWrtRepCh(fpout, repaircurr, repairtot, "repair", fldcnt);
	mWrtRepCh(fpout, fhullcurr, fhulltot, "f. hull", fldcnt);
	mWrtRepCh(fpout, ahullcurr, ahulltot, "a. hull", fldcnt);
	mWrtRepCh(fpout, chullcurr, chulltot, "c. hull", fldcnt);
	mWrtRepCh(fpout, traccurr, tractot, "trac", fldcnt);
	mWrtRepCh(fpout, excesscurr, excesstot, "ex dam", fldcnt);
	mWrtRepCh(fpout, transcurr, transtot, "trans", fldcnt);
	mWrtRepCh(fpout, shutcurr, shuttot, "shut", fldcnt);
	mWrtRepCh(fpout, bttycurr, bttytot, "btty", fldcnt);
	mWrtRepCh(fpout, labcurr, labtot, "labs", fldcnt);
	mWrtRepCh(fpout, cargocurr, cargotot, "cargo", fldcnt);
	mWrtRepCh(fpout, armourcurr, armourtot, "armour", fldcnt);
	if (cloaktot > 0) {
		fpout << ", cloak cost " << ((unsigned int)(cloaktot)); fldcnt++;
	}
	mWrtRepCh(fpout, damcongrpcurr, damcongrptot, "damcon", fldcnt);
	mWrtRepCh(fpout, probecurr, probetot, "probes", fldcnt);
	mWrtRepCh(fpout, barrackscurr, barrackstot, "barracks", fldcnt);
	mWrtRepCh(fpout, weaponscurr, weaponstot, "weapons", fldcnt);
	mWrtRepCh(fpout, shuttlesbase, shuttlesmax, "shuttles", fldcnt);
	mWrtRepCh(fpout, marinesbase, marinesmax, "marines", fldcnt);
	mWrtRepCh(fpout, tbombsbase, tbombsmax, "bombs", fldcnt);
	mWrtRepCh(fpout, sparesbase, sparesmax, "parts", fldcnt);
	if (droneracks > 0) {
		fldcnt = 10;
		if (dronetype == 0) {
			if (dronespeed == 0) {
				mWrtRepCh(fpout, currdrones, maxdrones, "I-slow drones", fldcnt);
			} else if (dronespeed == 1) {
				mWrtRepCh(fpout, currdrones, maxdrones, "I-med drones", fldcnt);
			} else if (dronespeed == 2) {
				mWrtRepCh(fpout, currdrones, maxdrones, "I-fast drones", fldcnt);
			} else {
				mWrtRepCh(fpout, currdrones, maxdrones, "I-??? drones", fldcnt);
			}
		} else if (dronetype == 1) {
			if (dronespeed == 0) {
				mWrtRepCh(fpout, currdrones, maxdrones, "II-slow drones", fldcnt);
			} else if (dronespeed == 1) {
				mWrtRepCh(fpout, currdrones, maxdrones, "II-med drones", fldcnt);
			} else if (dronespeed == 2) {
				mWrtRepCh(fpout, currdrones, maxdrones, "II-fast drones", fldcnt);
			} else {
				mWrtRepCh(fpout, currdrones, maxdrones, "II-??? drones", fldcnt);
			}
		} else if (dronetype == 2) {
			if (dronespeed == 0) {
				mWrtRepCh(fpout, currdrones, maxdrones, "III-slow drones", fldcnt);
			} else if (dronespeed == 1) {
				mWrtRepCh(fpout, currdrones, maxdrones, "III-med drones", fldcnt);
			} else if (dronespeed == 2) {
				mWrtRepCh(fpout, currdrones, maxdrones, "III-fast drones", fldcnt);
			} else {
				mWrtRepCh(fpout, currdrones, maxdrones, "III-??? drones", fldcnt);
			}
		} else if (dronetype == 3) {
			if (dronespeed == 0) {
				mWrtRepCh(fpout, currdrones, maxdrones, "IV-slow drones", fldcnt);
			} else if (dronespeed == 1) {
				mWrtRepCh(fpout, currdrones, maxdrones, "IV-med drones", fldcnt);
			} else if (dronespeed == 2) {
				mWrtRepCh(fpout, currdrones, maxdrones, "IV-fast drones", fldcnt);
			} else {
				mWrtRepCh(fpout, currdrones, maxdrones, "IV-??? drones", fldcnt);
			}
		} else {
			if (dronespeed == 0) {
				mWrtRepCh(fpout, currdrones, maxdrones, "??-slow drones", fldcnt);
			} else if (dronespeed == 1) {
				mWrtRepCh(fpout, currdrones, maxdrones, "??-med drones", fldcnt);
			} else if (dronespeed == 2) {
				mWrtRepCh(fpout, currdrones, maxdrones, "??-fast drones", fldcnt);
			} else {
				mWrtRepCh(fpout, currdrones, maxdrones, "??-??? drones", fldcnt);
			}
		}
		fpout << " in " << ((int)(droneracks)) << " rack(s) on " << numhardpoints;
		fpout << " hardpoint(s), hdpt stats (#ready drones, racks, rack size, storage): ";
		for (i = 0; i < numhardpoints; i++) {
			fpout << "(";
			fpout << ((int)(readydrones_hp[i])) << ",";
			fpout << ((int)(numracks_hp[i])) << ",";
			fpout << ((int)(racksize_hp[i])) << ",";
			fpout << ((int)(currdrones_hp[i])) << ") ";
		}
	}
	long numftrs = 0;
	for (i = 0; i < 4; i++) numftrs += fighterbays[i].maxnum;
	if (numftrs > 0) {
		fpout << "," << endl << "     ftr bays:";
		for (i = 0; i < 4; i++) {
			if (fighterbays[i].maxnum > 0) {
				fpout << " " << ((int)(fighterbays[i].currnum));
				fpout << "/" << ((int)(fighterbays[i].maxnum)) << " ";
				for (j = 0; j < fighterbays[i].act_size; j++) {
					fpout << fighterbays[i].act_ftr[j];
				}
				fpout << ",";
			}
		}
	}
	fpout << endl << endl;
}

bool tShipObject::mUpdateSystem()
{
	char cmd;
	unsigned int  entry;

	cout << "Select a system to edit:" << endl;
	cout << "   P to edit power systems (warp, impulse, etc)" << endl;
	cout << "   C to edit command/control systems (bridge, sensors, dam con, etc)" << endl;
	cout << "   R to edit repair systems (damage control, repair etc)" << endl;
	cout << "   H to edit hull systems (cargo, armour, hull, barracks, etc)" << endl;
	cout << "   S to edit science systems (probe, labs, cloak, tractors, etc)" << endl;
	cout << "   I to edit inventory systems (marines, shuttles, spare parts, etc)" << endl;
	cout << "   X to try directly assigning extra scatterpacks, weasels, and suicide shuttles to the ship" << endl;
	cout << "   or Q to quit" << endl;
	cin >> cmd;
	switch (cmd) {
		case 'Q': case 'q': return false;

		case 'P': case 'p':
				cout << "Enter the amount of right warp engines (currently: ";
				cout << ((unsigned int)(rwarptot)) << ")";
				cin >>   entry;
				rwarptot = (char)(entry & 255);
				rwarpcurr = rwarptot;

				cout << "Enter the amount of left warp engines (currently: ";
				cout << ((unsigned int)(lwarptot)) << ")";
				cin >>   entry;
				lwarptot = (char)(entry & 255);
				lwarpcurr = lwarptot;

				cout << "Enter the amount of center warp engines (currently: ";
				cout << ((unsigned int)(cwarptot)) << ")";
				cin >>   entry;
				cwarptot = (char)(entry & 255);
				cwarpcurr = cwarptot;

				cout << "Enter the amount of impulse engines (currently: ";
				cout << ((unsigned int)(impulsetot)) << ")";
				cin >>   entry;
				impulsetot = (char)(entry & 255);
				impulsecurr = impulsetot;

				cout << "Enter the amount of aux. power (currently: ";
				cout << ((unsigned int)(aprtot)) << ")";
				cin >>   entry;
				aprtot = (char)(entry & 255);
				aprcurr = aprtot;

				cout << "Enter the amount of batteries (currently: ";
				cout << ((unsigned int)(bttytot)) << ")";
				cin >>   entry;
				bttytot = (char)(entry & 255);
				bttycurr = bttytot;
				break;

		case 'C': case 'c':
				cout << "Enter the amount of bridge (currently: ";
				cout << ((unsigned int)(bridgetot)) << ")";
				cin >>   entry;
				bridgetot = (char)(entry & 255);
				bridgecurr = bridgetot;

				cout << "Enter the amount of sensor boxes (currently: ";
				cout << ((unsigned int)(sensortot)) << ")";
				cin >>   entry;
				sensortot = (char)(entry & 255);
				sensorcurr = sensortot;

				cout << "Enter the amount of scanner boxes (currently: ";
				cout << ((unsigned int)(scannertot)) << ")";
				cin >>   entry;
				scannertot = (char)(entry & 255);
				scannercurr = scannertot;
				break;

		case 'R': case 'r':
				cout << "Enter the amount of damage control boxes (currently: ";
				cout << ((unsigned int)(damcontot)) << ")";
				cin >>   entry;
				damcontot = (char)(entry & 255);
				damconcurr = damcontot;

				cout << "Enter the damage control group (currently: ";
				cout << ((unsigned int)(damcongrptot)) << ")";
				cin >>   entry;
				damcongrptot = (char)(entry & 255);
				damcongrpcurr = damcongrptot;

				cout << "Enter the amount of repair (currently: ";
				cout << ((unsigned int)(repairtot)) << ")";
				cin >>   entry;
				repairtot = (char)(entry & 255);
				repaircurr = repairtot;
				break;

		case 'H': case 'h':
				cout << "Enter the amount of forward hull (currently: ";
				cout << ((unsigned int)(fhulltot)) << ")";
				cin >>   entry;
				fhulltot = (char)(entry & 255);
				fhullcurr = fhulltot;

				cout << "Enter the amount of aft hull (currently: ";
				cout << ((unsigned int)(ahulltot)) << ")";
				cin >>   entry;
				ahulltot = (char)(entry & 255);
				ahullcurr = ahulltot;

				cout << "Enter the amount of center hull (currently: ";
				cout << ((unsigned int)(chulltot)) << ")";
				cin >>   entry;
				chulltot = (char)(entry & 255);
				chullcurr = chulltot;

				cout << "Enter the amount of excess damage (currently: ";
				cout << ((unsigned int)(excesstot)) << ")";
				cin >>   entry;
				excesstot = (char)(entry & 255);
				excesscurr = excesstot;

				cout << "Enter the amount of cargo (currently: ";
				cout << ((unsigned int)(cargotot)) << ")";
				cin >>   entry;
				cargotot = (char)(entry & 255);
				cargocurr = cargotot;

				cout << "Enter the amount of armour (currently: ";
				cout << ((unsigned int)(armourtot)) << ")";
				cin >>   entry;
				armourtot = (char)(entry & 255);
				armourcurr = armourtot;

				cout << "Enter the amount of barracks (currently: ";
				cout << ((unsigned int)(barrackstot)) << ")";
				cin >>   entry;
				barrackstot = (char)(entry & 255);
				barrackscurr = barrackstot;
				break;

		case 'S': case 's':
				cout << "Enter the amount of tractors (currently: ";
				cout << ((unsigned int)(tractot)) << ")";
				cin >>   entry;
				tractot = (char)(entry & 255);
				traccurr = tractot;

				cout << "Enter the amount of transporters (currently: ";
				cout << ((unsigned int)(transtot)) << ")";
				cin >>   entry;
				transtot = (char)(entry & 255);
				transcurr = transtot;

				cout << "Enter the amount of labs (currently: ";
				cout << ((unsigned int)(labtot)) << ")";
				cin >>   entry;
				labtot = (char)(entry & 255);
				labcurr = labtot;

				cout << "Enter the cost of cloak (currently: ";
				cout << ((unsigned int)(cloaktot)) << ")";
				cin >>   entry;
				cloaktot = (char)(entry & 255);
				cloakcurr = cloaktot;

				cout << "Enter the amount of probes (currently: ";
				cout << ((unsigned int)(probetot)) << ")";
				cin >>   entry;
				probetot = (char)(entry & 255);
				probecurr = probetot;
				break;

		case 'I': case 'i':
				cout << "Enter the number of shuttle boxes (currently: ";
				cout << ((unsigned int)(shuttot)) << ")";
				cin >>   entry;
				shuttot = (char)(entry & 255);
				shutcurr = shuttot;

				cout << "Enter the maximum number of shuttles (currently: ";
				cout << ((unsigned int)(shuttlesmax)) << ")";
				cin >>   entry;
				shuttlesmax = (char)(entry & 255);
				shuttlescur = shuttlesmax / 2;

				cout << "Enter the maximum number of marines (currently: ";
				cout << ((unsigned int)(marinesmax)) << ")";
				cin >>   entry;
				marinesmax = (char)(entry & 255);
				marinesbase = marinesmax / 2;
				marinescur = marinesmax;

				cout << "Enter the maximum number of spares (currently: ";
				cout << ((unsigned int)(sparesmax)) << ")";
				cin >>   entry;
				sparesmax = (char)(entry & 255);
				sparesbase = sparesmax / 2;
				sparescur = sparesmax;

				cout << "Enter the maximum number of t-bombs (currently: ";
				cout << ((unsigned int)(tbombsmax)) << ")";
				cin >>   entry;
				tbombsmax = (char)(entry & 255);
				tbombsbase = tbombsmax / 2;
				tbombscur = tbombsmax;
				break;

		case 'X': case 'x':
				cout << "Allocating extra specialty shuttles to the ship" << endl;
				cout << "Enter the number of extra pre-built scatterpacks to be assigned" << endl;
				cin >> entry;
				shipstate[336] = shipstate[337] = shipstate[338] = (char)(entry & 255);
				cout << "Enter the number of extra pre-built suicide shuttles to be assigned" << endl;
				cin >> entry;
				shipstate[339] = shipstate[340] = shipstate[341] = (char)(entry & 255);
				cout << "Enter the number of extra pre-built wild weasels to be assigned" << endl;
				cin >> entry;
				shipstate[342] = shipstate[343] = shipstate[344] = (char)(entry & 255);
				break;
		default: cout << "Invalid system, please try again" << endl;
	}
	return true;
}

bool tShipObject::mModifyShip()
{
	char cmd;
	long entry;
	char newline[256];
	bool quit = false;
	bool updateplayer = false;
	long difference;
	int i, j;
	bool doneediting = false;

	do {
		cout << endl;
		cout << "Enter T to assign a new ship type from the shiplist" << endl;
		cout << endl;
		cout << "   or R to repair all ship systems" << endl;
		cout << "   or S to supply full load of parts, marines, t-bombs, drones, and fighters" << endl;
		cout << "   or F to modify the ship fighters" << endl;
		cout << endl;
		cout << "   or E to edit ship (non-weapon) systems" << endl;
		cout << "   or D to edit existing ship drone systems" << endl;
		cout << "   or W to edit existing ship weapon (non-drone) systems" << endl;
		cout << endl;
		cout << "   or B to edit ship BPV" << endl;
		cout << "   or C to edit ship EPV (economic bpv)" << endl;
		cout << "   or H to modify ship hull class" << endl;
		cout << "   or N to modify ship name" << endl;
		cout << "   or P to change the player race for the ship" << endl;
		cout << endl;
		cout << "   or Q to quit editing this ship" << endl;
		cin >> cmd;
		switch (cmd) {

			case 'P':
			case 'p':
				cout << "Enter the new race (currently:" << race << ")" << endl;
				cout << "0=Fed,1=Kli,2=Rom,3=Lyr,4=Hyd,5=Gor,6=ISC,7=Mir" << endl;
				if (!gIsEAWCampaign()) {
					cout << "8=Ori,9=Kor,10=Pri,11=Tig,12=Bea,13=Syn,14=Wyl,15=Cam" << endl;
				}
				cin >> race;
				break;

			case 'B':
			case 'b':
				cout << "Enter the new BPV (currently:";
				cout << shipbpv1 << ")" << endl;
				cin >> shipbpv1;
				updateplayer = true;
				break;

			case 'C':
			case 'c':
				cout << "Enter the new EPV (currently:";
				cout << shipepv << ")" << endl;
				cin >> shipepv;
				break;

			case 'H':
			case 'h':
				cout << "Enter the new ship hull class (currently:";
				cout << hullclass << ")" << endl;
				cout << "(1=PF,2=Frtr,3=FF,4=DD,5=DW,6=CL,7=CA,8=NCA,9=BCH,10=CV,11=DN,";
				cout << "(12=BB,13=LP,14=BS,15=BATS,16=SB,17=Monster,18=Planet,19=Special" << endl;
				cin >> hullclass;
				updateplayer = true;
				break;

			case 'N':
			case 'n':
				cout << "Enter the new ship name (currently:";
				for (i = 0; i < namelen; i++) {
					cout << namestr[i];
				}
				cin.getline(newline, 255); // to get rid of buffer garbage
				cout << ")" << endl;
				cin.getline(newline, 255);
				difference = strlen(newline) - namelen;
				size1 += difference;
				size2 += difference;
				namelen = strlen(newline);
				for (i = 0; i < namelen; i++) {
					namestr[i] = newline[i];
				}
				updateplayer = true;
				break;

			case 'T':
			case 't':
				cout << "Enter the new ship type (currently:";
				for (i = 0; i < typelen; i++) {
					cout << typestr[i];
				}
				cout << ")" << endl;
				cin.getline(newline, 255); // to get rid of buffer garbage
				cin.getline(newline, 255);
				difference = strlen(newline) - typelen;
				size1 += difference;
				size2 += difference;
				typelen = strlen(newline);
				for (i = 0; i < typelen; i++) {
					typestr[i] = newline[i];
				}
				mGetShipDataFromShiplist();
				updateplayer = true;
				break;

			case 'E':
			case 'e':
				cout << "Editing ship (non weapon) systems" << endl;
				do {
					doneediting = mUpdateSystem();
				} while (!doneediting);

				break;


			case 'W':
			case 'w':
				cout << "Editing ship weapon systems: currently you can only increase/decrease the ";
				cout << "number of weapons mounted on any hardpoint, not add new weapons or change types";
				cout << " (the shiplist entry for the hardpoint regulates the weapon type used)" << endl;
				weaponscurr = weaponstot;
				weaponstot = 0;
				for (i = 0; i < 25; i++) {
					if (shipstate[59 + (2*i)] == 0) continue;
					cout << "Enter the number of weapons on hardpoint ";
					cout << i << " (currently: ";
					cout << ((unsigned int)(shipstate[59 + (2*i)])) << ")";
					cin >> entry;
					shipstate[59 + (2*i)] = (char)(entry & 255);
					shipstate[60 + (2*i)] = shipstate[59 + (2*i)];
					weaponstot += shipstate[60 + (2*i)];
				}
				weaponscurr = weaponstot;

			case 'D':
			case 'd':
				cout << "Drone editing is only partially supported" << endl;
				cout << "Enter F for fast drones, M for medium speed, anything else for slow drones" << endl;
				char c;
				cin >> c;
				if ((c == 'F') || (c == 'f')) dronespeed = 2;
				else if ((c == 'M') || (c == 'm')) dronespeed = 1;
				else dronespeed = 0;
				cout << "Enter 1 for type I drones, 2 for type II, 3 for type III, anything else for type IV" << endl;
				cin >> c;
				if (c == '1') dronetype = 0;
				else if (c == '2') dronetype = 1;
				else if (c == '3') dronetype = 2;
				else dronetype = 3;
				break;
				  /******************
				  for drone rack hardpoints you'll need to figure out the reload info here
   // prep the drone rack information
   droneracks = 0;
   shipstate[125] = 0;
   // all ships carry type I drones by default
   dronetype = 0;
   shipstate[121] = 0;
   // drone speed is based on the current era
   dronespeed = gGetCurrentEra();
   shipstate[122] = gGetCurrentEra();
   // all ships get 2 loads of reloads by default
   dronereloads = 2;
   shipstate[123] = 2;

// now get the 25 weapon patterns: number, type, and arc
   weaponstot = 0;

   for (i = 0; i < 25; i++) {
      // Num
      getnextfield(nextfield, fpin);
      if (fpin.eof()) return ;
      long count = atoi(nextfield.c_str());
      shipstate[59 + (2*i)] =  count & 255ul;
	  shipstate[60 + (2*i)] = shipstate[59 + (2*i)];
	  weaponstot += shipstate[59 + (2*i)];
	  weaponscurr = weaponstot;

      // Type
      getnextfield(nextfield, fpin);
      if (fpin.eof()) return ;

	  // if it's a drone rack we have to update the appropriate information
	  if (strncmp(nextfield.c_str(), "Dro", 3) == 0) {

		  // update the total number of drone racks
		  droneracks += shipstate[59 + (2 * i)];
		  shipstate[125] = droneracks;

		  // update the number of drone racks for this hardpoint
		  shipstate[137 + (8 * i)] = shipstate[59 + (2 * i)];

		  // update the drone storage for the rack and overall storage,
		  // and update the size of the current rack
		  switch (nextfield[3]) {
			  case 'C':
			  case 'B':
				  shipstate[139 + (8 * i)] = 6;
				  shipstate[135 + (8 * i)] = (12 * count) & 255ul;
				  maxdrones += (6 * shipstate[59 + (2 * i)]);
				  currdrones += (6 * shipstate[59 + (2 * i)]);
				  break;
			  default:
				  shipstate[139 + (8 * i)] = 4;
				  shipstate[135 + (8 * i)] = (8 * count) & 255ul;
				  maxdrones += (4 * shipstate[59 + (2 * i)]);
				  currdrones += (4 * shipstate[59 + (2 * i)]);
				  break;
		  }
	  }

	  // if it isn't a drone rack we have to make sure the matching
	  //    drone entry is empty
	  else {
		  shipstate[135 + (8 * i)] = 0;
		  shipstate[137 + (8 * i)] = 0;
		  shipstate[139 + (8 * i)] = 0;
	  }
				  ********************/
				

			case 'F':
			case 'f':
				cout << endl << "Updating ship fighter information" << endl << endl;
				for (i = 0; i < 4; i++) {
					cout << "Enter the maximum number of fighters for bay " << i << " (currently ";
					cout << ((unsigned int)(fighterbays[i].maxnum)) << "):";
					cin >> entry;
					fighterbays[i].maxnum = (char)(entry & 255);
					fighterbays[i].currnum = fighterbays[i].maxnum;
					cout << "Enter the type of fighters for the bay (e.g. Hornet.I):";
					cin.getline(newline, 255); // to get rid of buffer garbage
					cin.getline(newline, 255);
					difference = 2 * strlen(newline);
					difference = difference - fighterbays[i].act_size;
					difference = difference - fighterbays[i].def_size;
					size1 += difference;
					size2 += difference;
					fighterbays[i].act_size = strlen(newline);
					fighterbays[i].def_size = fighterbays[i].act_size;
					delete fighterbays[i].act_ftr;
					fighterbays[i].act_ftr = new char[fighterbays[i].act_size];
					for (j = 0; j < fighterbays[i].act_size; j++) {
						fighterbays[i].act_ftr[j] = newline[j];
						fighterbays[i].default_ftr[j] = newline[j];
					}
				}
				break;

			case 'r':
			case 'R':
				cout << "Repairing all ship systems" << endl;
				rwarpcurr = rwarptot;
				lwarpcurr = lwarptot;
				cwarpcurr = cwarptot;
				impulsecurr = impulsetot;
				aprcurr = aprtot;
				bridgecurr = bridgetot;
				sensorcurr = sensortot;
				scannercurr = scannertot;
				damconcurr = damcontot;
				damcongrpcurr = damcongrptot;
				shutcurr = shuttot;
				repaircurr = repairtot;
				fhullcurr = fhulltot;
				ahullcurr = ahulltot;
				chullcurr = chulltot;
				traccurr = tractot;
				excesscurr = excesstot;
				transcurr = transtot;
				bttycurr = bttytot;
				labcurr = labtot;
				cargocurr = cargotot;
				armourcurr = armourtot;
				cloakcurr = cloaktot;
				probecurr = probetot;
				barrackscurr = barrackstot;
				weaponscurr = weaponstot;
				for (i = 0; i < 25; i++) {
					shipstate[60 + (2*i)] = shipstate[59 + (2*i)];
				}
				break;

			case 's':
			case 'S':
				cout << "Restocking all ship supplies" << endl;
				shuttlescur = shuttlesmax;
				marinesbase = marinesmax;
				marinescur = marinesmax;
				tbombsbase = tbombsmax;
				tbombscur = tbombsmax;
				sparesbase = sparesmax;
				sparescur = sparesmax;
				dronespeed = gGetCurrentEra();
				if (currdrones < maxdrones) currdrones = maxdrones;
				else if (maxdrones < currdrones) maxdrones = currdrones;
				for (i = 0; i < 4; i++) {
					if (fighterbays[i].maxnum > 0) {
						fighterbays[i].currnum = fighterbays[i].maxnum;
					}
				}
				break;


			case 'q':
			case 'Q': 
				quit = true;
				break;

			default:
				cout << "Invalid command choice entered, please try again" << endl;
				break;
		}
		if (quit != true) shipedited = true;
	} while (quit == false);
	return updateplayer;
}
void tShipObject::mWrtRepCh(ofstream& fpout, char curr, char total, char *name, int &fieldcount)
{
	if (total == 0) return;

	if (fieldcount >= 10) {
		fieldcount = 1;
		fpout << "," << endl << "     ";
	} else {
		fieldcount++;
		fpout << ", " ;
	}
	fpout << name << " ";
	fpout << (((long)(curr)) & (255ul)) << "/" << (((long)(total)) & (255ul));
}

void tShipObject::mGetShipDataFromShiplist()
{
	int i;
	cout << "(Assuming shiplist.txt is available in this directory)" << endl;
	ifstream fpin;
	fpin.open("shiplist.txt");
	if (fpin.fail()) {
		cout << endl;
		cout << "================================" << endl;
		cout << "WARNING: UNABLE TO OPEN SHIPLIST" << endl;
		cout << "You will need to enter the ship system information using the edit menu" << endl;
		cout << "======================================================================" << endl;
		cout << endl;
		return;
	}

	bool found = false;
	/*
	FIRST FIND THE MATCHING SHIP LINE IN THE SHIPLIST FILE
	   (if none found then generate error message)
	*/
   // get rid of the two junk lines at the start of the file
   const MAXSTRLEN = 2048;
   char info[MAXSTRLEN];
   std::string nextfield;
   fpin.getline(info, MAXSTRLEN-1);
   fpin.getline(info, MAXSTRLEN-1);

   std::string tmpshiprace;
   std::string tmpshiphull;
   do {
	   // grab temp copies of the race and hull type fields
       getnextfield(tmpshiprace, fpin);
       getnextfield(tmpshiphull, fpin);

	   // grab the class and compare it against the typestr,
	   // throw out the rest of the line if it isn't the ship we're looking for
       getnextfield(nextfield, fpin);
	   if (0 == strcmp(nextfield.c_str(), typestr)) {
		   found = true;
	   } else {
			fpin.getline(info, MAXSTRLEN-1);
	   }
   } while ((!found) && (!fpin.eof()));

	if (!found) {
		cout << endl;
		cout << "=======================================================" << endl;
		cout << "WARNING: UNABLE TO FIND SPECIFIED SHIP TYPE IN SHIPLIST" << endl;
		cout << "You will need to enter the ship system information using the edit menu" << endl;
		cout << "======================================================================" << endl;
		cout << endl;
		fpin.close();
		return;
	}

	/*
	THEN READ APPROPRIATE SHIP INFO FROM SHIPLIST 
	*/
	shipedited = true;

// 4. Class Type, e.g. "Frigate" etc
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return;
   if (nextfield == "SHUTTLE") hullclass = 0;
   if (nextfield == "PSEUDOFIGHTER") hullclass = 1;
   if (nextfield == "FREIGHTER") hullclass = 2;
   if (nextfield == "FRIGATE") hullclass = 3;
   if (nextfield == "DESTROYER") hullclass = 4;
   if (nextfield == "WAR_DESTROYER") hullclass = 5;
   if (nextfield == "LIGHT_CRUISER") hullclass = 6;
   if (nextfield == "HEAVY_CRUISER") hullclass = 7;
   if (nextfield == "NEW_HEAVY_CRUISER") hullclass = 8;
   if (nextfield == "HEAVY BATTLECRUISER") hullclass = 9;
   if (nextfield == "CARRIER") hullclass = 10;
   if (nextfield == "DREADNOUGHT") hullclass = 11;
   if (nextfield == "BATTLESHIP") hullclass = 12;
   if (nextfield == "LISTENING_POST") hullclass = 13;
   if (nextfield == "BASE_STATION") hullclass = 14;
   if (nextfield == "BATTLE_STATION") hullclass = 15;
   if (nextfield == "STARBASE") hullclass = 16;
   if (nextfield == "MONSTER") hullclass = 17;
   if (nextfield == "PLANET") hullclass = 18;
   if (nextfield == "SPECIAL") hullclass = 19;

// 5. BPV
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return;
   shipbpv1 = atoi(nextfield.c_str());
   shipepv = atoi(nextfield.c_str());

// 6. Special Role
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 7. Year First Available
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 8. Year Last Available
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 9. Size Class
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 10. Turn mode
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 11. Move Cost
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 12. HET +2 Turns & Nimble
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 13. HET Breakdown
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 14. Stealth (+ECM) 
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 15. Regular Crew
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 16. Boarding Parties Base
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   marinesbase = atoi(nextfield.c_str()) & 255ul;
   marinescur = marinesbase;

// 17. Boarding Parties Max
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   marinesmax = atoi(nextfield.c_str()) & 255ul;

// 18. Deck Crews
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 19. Total Crew
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 20. Min Crew
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 21. Shield 1
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 22. Shield 2 _ 6
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 23. Shield 3 _ 5
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 24. Shield 4
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 25. Shield Total
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 26. Cloak
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   cloaktot = atoi(nextfield.c_str()) &255ul;
   cloakcurr = cloaktot;
   shipstate[51] = shipstate[52] = cloaktot;

   // prep the drone rack information
   droneracks = 0;
   shipstate[125] = 0;
   // all ships carry type I drones by default
   dronetype = 0;
   shipstate[121] = 0;
   // drone speed is based on the current era
   dronespeed = gGetCurrentEra();
   shipstate[122] = gGetCurrentEra();
   // all ships get 2 loads of reloads by default
   dronereloads = 2;
   shipstate[123] = 2;

// now get the 25 weapon patterns: number, type, and arc
   weaponstot = 0;

   for (i = 0; i < 25; i++) {
      // Num
      getnextfield(nextfield, fpin);
      if (fpin.eof()) return ;
      long count = atoi(nextfield.c_str());
      shipstate[59 + (2*i)] =  count & 255ul;
	  shipstate[60 + (2*i)] = shipstate[59 + (2*i)];
	  weaponstot += shipstate[59 + (2*i)];
	  weaponscurr = weaponstot;

      // Type
      getnextfield(nextfield, fpin);
      if (fpin.eof()) return ;

	  // if it's a drone rack we have to update the appropriate information
	  if (strncmp(nextfield.c_str(), "Dro", 3) == 0) {

		  // update the total number of drone racks
		  droneracks += shipstate[59 + (2 * i)];
		  shipstate[125] = droneracks;

		  // update the number of drone racks for this hardpoint
		  shipstate[137 + (8 * i)] = shipstate[59 + (2 * i)];

		  // update the drone storage for the rack and overall storage,
		  // and update the size of the current rack
		  switch (nextfield[3]) {
			  case 'C':
			  case 'B':
				  shipstate[139 + (8 * i)] = 6;
				  shipstate[135 + (8 * i)] = (12 * count) & 255ul;
				  maxdrones += (12 * shipstate[59 + (2 * i)]);
				  currdrones += (12 * shipstate[59 + (2 * i)]);
				  break;
			  default:
				  shipstate[139 + (8 * i)] = 4;
				  shipstate[135 + (8 * i)] = (8 * count) & 255ul;
				  maxdrones += (8 * shipstate[59 + (2 * i)]);
				  currdrones += (8 * shipstate[59 + (2 * i)]);
				  break;
		  }
	  }

	  // if it isn't a drone rack we have to make sure the matching
	  //    drone entry is empty
	  else {
		  shipstate[135 + (8 * i)] = 0;
		  shipstate[137 + (8 * i)] = 0;
		  shipstate[139 + (8 * i)] = 0;
	  }

      // Arc
      getnextfield(nextfield, fpin);
      if (fpin.eof()) return ;

   }

// Now update the drone rack information
	char racksprocessed = 0;
	int offset = 135;
	numhardpoints = 0;
	while ((racksprocessed < droneracks) && (offset < 325)) {
		if (shipstate[offset+2] > 0) {
			racksprocessed += shipstate[offset+2];
			currdrones_hp[numhardpoints] = shipstate[offset];
			numracks_hp[numhardpoints] = shipstate[offset+2];
			racksize_hp[numhardpoints] = shipstate[offset+4];
			dataoffset_hp[numhardpoints] = offset;
			numhardpoints++;
		}
		offset += 8;
	}


// 102. Probes
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   probetot = atoi(nextfield.c_str()) & 255ul;
   probecurr = probetot;
   shipstate[55] = shipstate[56] = probetot;

// 103. T Bombs Base
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   tbombsbase = atoi(nextfield.c_str()) & 255ul;
   tbombscur = tbombsbase;

// 104. T Bombs Max
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   tbombsmax = atoi(nextfield.c_str()) & 255ul;

// 105. Nuclear Mine Base
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 106. Nuclear Mine Max
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 107. Drone Control
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 108. ADD_6
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 109. ADD_12
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 110. Shuttles Size
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   shuttot = atoi(nextfield.c_str());
   shutcurr = shuttot;
   shipstate[41] = shipstate[42] = shutcurr;

// 111. Launch Rate
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 112. General Base
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   shuttlesbase = atoi(nextfield.c_str());

// 113. General Max
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   shuttlesmax = atoi(nextfield.c_str());
   shuttlescur = shuttlesbase;
   shipstate[333] = shuttlesbase;
   shipstate[334] = shuttlesmax;
   shipstate[335] = shuttlescur;


// Then for 114 through 121 get num fighters and their type
   for (int j = 0; j < 4; j++) {
      // 120. Fighter Bay 4
      getnextfield(nextfield, fpin);
      if (fpin.eof()) return ;
	  fighterbays[j].maxnum = atoi(nextfield.c_str()) & 255ul;
	  fighterbays[j].defnum = fighterbays[j].maxnum;
	  fighterbays[j].currnum = fighterbays[j].maxnum;
   
      // 121. Fighter Type 4
      getnextfield(nextfield, fpin);
      if (fpin.eof()) return ;
	  size1 = size1 - fighterbays[j].act_size;
	  size1 = size1 - fighterbays[j].def_size;
	  delete fighterbays[j].act_ftr;
	  delete fighterbays[j].default_ftr;
	  if (fighterbays[j].maxnum > 0) {
		  fighterbays[j].def_size = strlen(nextfield.c_str());
		  fighterbays[j].act_size = strlen(nextfield.c_str());
		  fighterbays[j].act_ftr = new char[strlen(nextfield.c_str())];
		  fighterbays[j].default_ftr = new char[strlen(nextfield.c_str())];
		  strncpy(fighterbays[j].act_ftr, nextfield.c_str(), strlen(nextfield.c_str()));
		  strncpy(fighterbays[j].default_ftr, nextfield.c_str(), strlen(nextfield.c_str()));
	  } else {
		  fighterbays[j].def_size = 0;
		  fighterbays[j].act_size = 0;
		  fighterbays[j].act_ftr = NULL;
		  fighterbays[j].default_ftr = NULL;
	  }
	  size1 += fighterbays[j].act_size;
	  size1 += fighterbays[j].def_size;
   }
   size2 = size1;

// 122. Armor
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   armourtot = atoi(nextfield.c_str()) & 255ul;
   armourcurr = armourtot;
   shipstate[49] = shipstate[50] = armourtot;

// 123. Forward Hull
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   fhulltot = atoi(nextfield.c_str()) & 255ul;
   fhullcurr = fhulltot;
   shipstate[29] = shipstate[30] = fhulltot;

// 124. Center Hull
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   chulltot = atoi(nextfield.c_str()) & 255ul;
   chullcurr = chulltot;
   shipstate[33] = shipstate[34] = chulltot;

// 125. Aft Hull
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   ahulltot = atoi(nextfield.c_str()) & 255ul;
   ahullcurr = ahulltot;
   shipstate[31] = shipstate[32] = ahulltot;

// 126. Cargo
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   cargotot = atoi(nextfield.c_str()) & 255ul;
   cargocurr = cargotot;
   shipstate[47] = shipstate[48] = cargotot;

// 127. Barracks
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   barrackstot = atoi(nextfield.c_str()) &255ul;
   barrackscurr = barrackstot;
   shipstate[57] = shipstate[58] = barrackstot;

// 128. Repair
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   repairtot = atoi(nextfield.c_str()) & 255ul;
   repaircurr = repairtot;
   shipstate[27] = shipstate[28] = repairtot;

// 129. R_L_Warp
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   rwarptot = atoi(nextfield.c_str()) & 255ul;
   rwarpcurr = rwarptot;
   lwarpcurr = rwarptot;
   lwarptot = rwarptot;
   shipstate[9] = shipstate[10] = shipstate[11] = shipstate[12] = rwarptot;

// 130. C_Warp
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   cwarptot = atoi(nextfield.c_str()) & 255ul;
   cwarpcurr = cwarptot;
   shipstate[13] = shipstate[14] = cwarptot;

// 131. Impulse
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   impulsetot = atoi(nextfield.c_str()) & 255ul;
   impulsecurr = impulsetot;
   shipstate[15] = shipstate[16] = impulsetot;

// 132. Apr
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   aprtot = atoi(nextfield.c_str()) & 255ul;
   aprcurr = aprtot;
   shipstate[17] = shipstate[18] = aprtot;


// 133. Battery
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   bttytot = atoi(nextfield.c_str()) &255ul;
   bttycurr = bttytot;
   shipstate[43] = shipstate[44] = bttytot;

// 134. Bridge
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   bridgetot = atoi(nextfield.c_str()) &255ul;
   bridgecurr = bridgetot;
   shipstate[19] = shipstate[20] = bridgetot;

// 135. Security
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 136. Lab
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   labtot = atoi(nextfield.c_str()) &255ul;
   labcurr = labtot;
   shipstate[45] = shipstate[46] = labtot;

// 137. Transporters
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   transtot = atoi(nextfield.c_str()) &255ul;
   transcurr = transtot;
   shipstate[39] = shipstate[40] = transtot;

// 138. Tractors
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   tractot = atoi(nextfield.c_str()) &255ul;
   traccurr = tractot;
   shipstate[35] = shipstate[36] = tractot;

// 139. Mech Tractors
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 140. Special Sensors
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 141. Sensors
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   sensortot = atoi(nextfield.c_str()) & 255ul;
   sensorcurr = sensortot;
   shipstate[21] = shipstate[22] = sensortot;

// 142. Scanners
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   scannertot = atoi(nextfield.c_str()) & 255ul;
   scannercurr = scannertot;
   shipstate[23] = shipstate[24] = scannertot;

// 143. Explosion Strength
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 144. Acceleration
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;

// 145. Damage Control
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   damcontot = atoi(nextfield.c_str()) & 255ul;
   damconcurr = damcontot;
   damcongrptot = damcongrpcurr = damconcurr;
   shipstate[25] = shipstate[26] = damcontot;
   shipstate[53] = shipstate[54] = damcongrptot;
   sparesmax = 5 * damcontot;
   sparesbase = 2 * damcontot;
   sparescur = sparesbase;

// 146. Extra Damage
   getnextfield(nextfield, fpin);
   if (fpin.eof()) return ;
   excesstot = atoi(nextfield.c_str()) & 255ul;
   excesscurr = excesstot;
   shipstate[37] = shipstate[38] = excesstot;

// THEN LOTS OF RUBBISH TO END IT
   fpin.getline(info, MAXSTRLEN-1);
   if (fpin.eof()) return ;

	fpin.close();
}

void tShipObject::getnextfield(std::string &s, ifstream &fpin)
{
   s = "";
   char c;
   do {
      fpin.get(c);
      if (fpin.eof()) return;
      if (c != '\t') s += c;
   } while (c != '\t');
}

void tShipObject::gGiveCurrentDrones()
{
	dronespeed = gGetCurrentEra();
}