#ifndef SHIPOBJECTH
#define SHIPOBJECTH 1

#include "commondefs.h"

class tShipObject {
public:
	tShipObject();
	tShipObject(ifstream& fpin, long size);
	~tShipObject();
	mWriteToDB(ofstream& fpout);
	mWriteToReport(ofstream& fpout);
	long mGetHullClass() { return hullclass; }
	long mGetCaptainID() { return captainid; }
	long mGetShipID() { return identifier; }
	bool mModifyShip();
	void gGiveCurrentDrones();

public:
	long shipbpv1;
	long hullclass;
	long typelen;
	char *typestr; // of size typelen
	long namelen;
	char *namestr; // of size namelen
	long race;

private:
	bool mUpdateSystem();
	void mGetShipDataFromShiplist();
	void mWrtRepCh(ofstream&fpout, char curr, char total, char *name, int &fieldcount);
	void getnextfield(std::string &s, ifstream &fpin);

	bool shipedited;
	long size1, size2;
	long hdrsize;
	char header[12];
	// here it is assumed the dual size fields,
	//     the header size, and the header string have all
	//     been read in prior to calling the constructor
	//     and supplying it with the object size
	long seperator;
	char objheader[6];
	long identifier;
	long seperator2;
	char unknown[5];
	long captainid;
	char auctionflag;
	long shipepv;
	char shipstate[449];
		// shipstate includes information on all the ship stores,
		// this is partly still to be decrypted

		// total RW and current RW
	char rwarptot, rwarpcurr;
		// total LW and current LW
	char lwarptot, lwarpcurr;
		// total CW and current CW
	char cwarptot, cwarpcurr;
		// total impulse and current impulse
	char impulsetot, impulsecurr;
		// total APR and current APR
	char aprtot, aprcurr;
		// total bridge and current bridge
	char bridgetot, bridgecurr;
		// total sensor and current sensor
	char sensortot, sensorcurr;
		// total scanner and current scanner
	char scannertot, scannercurr;
		// total damage control and current damage control
	char damcontot, damconcurr;
		// total repair and current repair
	char repairtot, repaircurr;
		// total fwd hull and current fwd hull
	char fhulltot, fhullcurr;
		// total aft hull and current aft hull
	char ahulltot, ahullcurr;
		// total ctr hull and current ctr hull
	char chulltot, chullcurr;
		// total tractors and current tractors
	char tractot, traccurr;
		// total excess dam and current excess dam
	char excesstot, excesscurr;
		// total transporters and current transporters
	char transtot, transcurr;
		// total btty and current btty
	char shuttot, shutcurr;
	    // current damage state of the shuttle bays
	char bttytot, bttycurr;
		// total lab and current lab
	char labtot, labcurr;
		// total cargo and current cargo
	char cargotot, cargocurr;
		// total armour and current armour
	char armourtot, armourcurr;
		// total barracks and current barracks
	char cloaktot, cloakcurr;
	    // damage control hardpoing status
	char damcongrptot, damcongrpcurr;
		// total probes and current probes
	char probetot, probecurr;
		// mech links or security stations?
	char barrackstot, barrackscurr;
		// total weapons and current weapons
	char weaponstot, weaponscurr;

	char marinesmax, marinesbase, marinescur;
	char tbombsmax, tbombsbase, tbombscur;
	char sparesmax, sparesbase, sparescur;
	// char deckcrewsmax, deckcrews1, deckcrews2;
	char shuttlesmax, shuttlescur, shuttlesbase;
	char dronetype, dronespeed, dronereloads, dronesready;
	char droneracks, maxdrones, currdrones;
	// drone rack data is split up by hardpoint,
	// the following variables track the relevant info on each hardpoint,
	// including where its data is stored in the string
	long numhardpoints, dataoffset_hp[8];
	char currdrones_hp[8], racksize_hp[8], numracks_hp[8], readydrones_hp[8];

	struct sFighterInfo {
		long act_size;
		char *act_ftr;
		long def_size;
		char *default_ftr;
		char currnum;
		char maxnum;
		char defnum;
		char ftrsep;
	};
	sFighterInfo fighterbays[4];

	char *restofdesc; // object size minus all the lengths above,
		// restofdesc includes the information on fighters for the ship
		// (type, number, damage, etc)
	long remaininglen;
};

#endif